#!/bin/sh
# This Program is freeware.
# You can use and modify this program at your own risk.
# the next line restarts using wish \
exec wish "$0" "--" "$@"
lappend auto_path [file join [file dirname $argv0] lib] 
package require Tk
package require msgcat
package require BWidget
package require treectrl
package require Img
package require TclMagick
package require TkMagick
package require sqlite

namespace import msgcat::*
msgcat::mcload [file join [file dirname $argv0] lang]
if {$tcl_platform(platform) == {unix} && [mclocale] == {ja_jp}} {
	option add *TreeCtrl.Font    {{-jis-*-*-*-*-*-16-*-*-*-*-*-*-*} 12}
	option add *Listbox.Font     {{-jis-*-*-*-*-*-16-*-*-*-*-*-*-*} 12}
	option add *Entry.Font       {{-jis-*-*-*-*-*-16-*-*-*-*-*-*-*} 12}
	option add *Labelframe.Font  {{-jis-*-*-*-*-*-16-*-*-*-*-*-*-*} 12}
	option add *Menu.Font        {{-jis-*-*-*-*-*-16-*-*-*-*-*-*-*} 12}
	option add *Label.Font       {{-jis-*-*-*-*-*-16-*-*-*-*-*-*-*} 12}
	option add *Radiobutton.Font {{-jis-*-*-*-*-*-16-*-*-*-*-*-*-*} 12}
	option add *Button.Font      {{-jis-*-*-*-*-*-16-*-*-*-*-*-*-*} 12}
}
# -- Icon Images --
image create photo icon_find -data {
   R0lGODlhEAAQAIUAAPwCBCQmJDw+PAwODAQCBMza3NTm5MTW1ISChOTy9Mzq
   7Kze5Kzm7HyChOT29Oz6/Nzy9Lzu7JTW3GTCzERCRLza3NTy9Nz29Mzu9Kzq
   9Ize7HTGzHzK1AwKDMTq7JTi7HTW5HzGzKzS1IzW5Hza5FTK1ESyvLTa3HTK
   1GzG1DyqtLzu9IzK1AT+/Dw+RAQGBATCxHRydMTCxAAAAAAAAAAAAAAAAAAA
   AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEAAAAALAAAAAAQABAAAAaS
   QIAQEBAMhkjBUEAoGA4EJXKJSCQUC0ZDCmg0hATHAxKRTCIEYYMiMFYsF0xG
   s+FUOl0BJRAweCIRHyATIRhpRAEAHSILIyQgJSYhJ4dIBBEoISkmKiuVSQgR
   IyEsEQgELVNCLgQVCiJRLQSfli9pMAQxMrRcQ1G6tAC9AL+7al+qxALACG1K
   w8oxBGt7yWBpfkEAIf5oQ3JlYXRlZCBieSBCTVBUb0dJRiBQcm8gdmVyc2lv
   biAyLjUNCqkgRGV2ZWxDb3IgMTk5NywxOTk4LiBBbGwgcmlnaHRzIHJlc2Vy
   dmVkLg0KaHR0cDovL3d3dy5kZXZlbGNvci5jb20AOw==
}
image create photo icon_viewthum -data {
   R0lGODlhEAAQAIIAAPwCBDQyNAQCBPz+/PzerAAAAAAAAAAAACH5BAEAAAAA
   LAAAAAAQABAAAAMwCLrcG1AwGOQbw6qANeCEB3pCSZpO6pgowJZqLKuUGE0d
   nuEhf8IL1kz1shSHDX8CACH+aENyZWF0ZWQgYnkgQk1QVG9HSUYgUHJvIHZl
   cnNpb24gMi41DQqpIERldmVsQ29yIDE5OTcsMTk5OC4gQWxsIHJpZ2h0cyBy
   ZXNlcnZlZC4NCmh0dHA6Ly93d3cuZGV2ZWxjb3IuY29tADs=
}
image create photo icon_viewlist -data {
   R0lGODlhEAAQAIAAAPwCBAQCBCH5BAEAAAAALAAAAAAQABAAAAIchI+py40B
   TQSwuovp3DXkv1ia1IHmIXLiyWJ+AQAh/mhDcmVhdGVkIGJ5IEJNUFRvR0lG
   IFBybyB2ZXJzaW9uIDIuNQ0KqSBEZXZlbENvciAxOTk3LDE5OTguIEFsbCBy
   aWdodHMgcmVzZXJ2ZWQuDQpodHRwOi8vd3d3LmRldmVsY29yLmNvbQA7
}
image create photo icon_viewprev -data {
   R0lGODlhEAAQAIYAAAQCBJx6NJR2LIxyNJR6NKSORKyaTJyGRJyORKSWTJyK
   RKSWRKyOPKSKPHRKLEwiFDwSDEQeDGxGJLSeTKSSRKyaVLyaPLyaTGQqFFwy
   HGwyFEQWFDQKDDQKFEwmFMSiTMyiVJRuNLx+LOS2VOy2ZNSKTFQeFGRGJLyq
   XMymVOSiVOy6ZOymZKxyTEQODDQOFLymVKxuNMRyJOSeNMx2FLxiJLRiHFQa
   DDwOFDQODFw+HLSiVHxSLFQiFIQ+HKxmNJxOLJRSLIxGHDwODGw+HNSSPOSW
   NNRyFOyyVOSOPARihNSORKRSFLR6TPz+/MTCxKTi9JTW7GSy1Lx2THw+FNSO
   XJRWNISChASq3ASWxARynEQaFMx+JJRSJFRWVARafARSdHxeLFw6HPz+7Pz+
   5GxKJDwSFIRSNHxGNPz+3MSCPNSWTMyGNPz+9AAAAAAAAAAAAAAAAAAAAAAA
   AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAAAAAAA
   LAAAAAAQABAAAAfXgACCg4SFggECAgMEBQYHBwgJCAoLggsMDA0ODxAREg0T
   CxQVghYWFxgZGhscHR4LE7GCHyAhIiMkJSatJyi+giApGCokKywtLhwvBzAw
   giMxGDIzNDU2Nzg5OjsTghc8PT4/QEFC2EMeCZUARKpFRkdISUr09YIYET0q
   S0wqTUpOnkCJIkWQhxsbpsigUsWKkidXsGTRIkjHgy0YuMjoYkKJFy9KvoAR
   FEZMBAg3UkIA6MTJGDKCBpQ5aebMGTQsx4xJU/FBBIxq1rAB4KTNS56Gkg7y
   EwgAIf5oQ3JlYXRlZCBieSBCTVBUb0dJRiBQcm8gdmVyc2lvbiAyLjUNCqkg
   RGV2ZWxDb3IgMTk5NywxOTk4LiBBbGwgcmlnaHRzIHJlc2VydmVkLg0KaHR0
   cDovL3d3dy5kZXZlbGNvci5jb20AOw==
}
image create photo icon_sort -data {
	R0lGODlhGgAQAKIAAFxaXP8AAAAA/wAAAP///wAAAAAAAAAAACH5BAUUAAQA
	LAAAAAAaABAAAANGSCraOi7KNeG8jEV7ZZZc1wgkuYmRRqgP6qgsEbrd/Aw4
	F+z7WeGOQEPosDWMBOItR1MoFYAcoPk8AmnKZ3SK5VWRzXAjAQA7
}
image create photo icon_zoom -data {
	R0lGODlhGgAQANUAAAAAAATCxHRydMTCxDw+PIzK1HTGzDyqtAD//7zu7CQm
	JGTCzLzu9Kze5Lza3FTK1OTy9HTK1Ize7HyChJTW3AQGBKzm7Mza3Nzy9HTW
	5MTq7KzS1MTW1NTy9IzW5Mzu9Oz6/ESyvNTm5GzG1Hza5LTa3AwODAAIADw+
	RHzGzISChOT29Mzq7HzK1JTi7Kzq9Nz29P///wAAAAAAAAAAAAAAAAAAAAAA
	AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAUUADEALAAAAAAaABAAAAaL
	wJgwpiCYhsikckioXEScCmFJZaogEFbDMplWl5UVCJOgLBKVr9Lk6MA+L4mh
	5TiqhwqRJpFwZRYpH2l3QiYbDR4kGQ8hKSWDhDEVCREpIyEHDJBKAJ2dVgke
	KQUJKhUIVZ5JKBUOLBtSCBWbSQBUs2kBFQIDtJFDUry+v5IEwsRKwb3IScHD
	xLNqQQA7
}



# Global Preference
array set pref {}
set pref(view) thum;# change view flag. trigger of change view event.
set pref(tree) thum;# save treectrl type(thum or list) for changing view from canvas to treectrl.
set pref(warn) 1
set pref(appname) ImageCatalog
set pref(encoding) [encoding system]
set pref(history) [file join [file dirname [file normalize $argv0]] .ImageCatalog_history]
set pref(app)  [list \
{C:\Program Files\Adobe\Photoshop 5.0J\Photoshp.exe} \
{C:\Program Files\susie346b\Susie.exe}]  ;# open with application list
set pref(quoteapp) [list Susie.exe];#These App need to quote args filename.

#These are Selected items info. and this value is variabled by menu objects.
set sel_importance {}
set sel_label {}
array set sel_category {}

namespace eval DB {
	variable db {}
	variable rootdir {}
	variable dbfile  {}
	
	# Basic DB Action
	# ===============================================
	# Open db file
	proc open {f} {
		variable db
		
		cd [file dirname $f]
		sqlite db [file tail $f]
		init $f
		return 0
	}
	
	# Create New Tables
	proc new {f} {
		variable db
		variable rootdir

		if {[file exists $f]} {
			file delete -force $f
		}
		cd [file dirname $f]
		sqlite db [file tail $f]
		# Create Tables
		db eval {
			create table tInfo (
				key   text,
				value text
			);
			create unique index iInfoKey on tInfo (key);
			create table tFile (
				id         integer primary key not null,
				filepath   text not null,
				filename   text not null,
				exists     boolean not null,
				width      integer,
				height     integer,
				size       integer not null,
				atime      datetime not null,
				ctime      datetime not null,
				mtime      datetime not null,
				comment    text,
				importance integer not null default 0,
				label      integer not null default 0,
				haveThumb  boolean not null default 0,
				thumb      text
			);
			create unique index iId on tFile(id);
			create unique index iPath on tFile(filepath);
			create index iComment  on tFile(comment);
			create index iLabel    on tFile(label);
			create index iATime on tFile(atime);
			create index iCTime on tFile(ctime);
			create index iMTime on tFile(mtime);
			create table tItemCategory (
				itemid    integer not null,
				catid     integer not null
			);
			create unique index iItemCategory on tItemCategory (itemid,catid);
			create table tLabel (
				id   integer primary key not null,
				name text
			);
			create table tCategory (
				id   integer primary key not null,
				name text not null
			);
		}
		# Set Default Infomation
		encoding system utf-8
		db eval "insert into tInfo (key,value) values ('rootdir', '[file normalize [file dirname $f]]')"
		# Set Label Names
		set i 0
		foreach name [list [mc None] [mc Label1] [mc Label2] [mc Label3] [mc Label4] \
			[mc Label5] [mc Label6] [mc Label7] [mc Label8] [mc Label9]] {
			db eval "insert into tLabel (id,name) values ($i, '$name')"
			incr i
		}
		encoding system $::pref(encoding)
		init $f
		return 0
	}
	
	# Init
	proc init {f} {
		variable dbfile
		variable rootdir
		if {$dbfile!={}} {return}

		set dbfile  $f
		set rootdir [file normalize [file dirname $f]]
	}

	# Close db file
	proc close {} {
		variable db
		variable dbfile
		variable rootdir

		if {$dbfile == {}} {return 1}
		db close
		set dbfile  {}
		set rootdir {}
	}
	
	
	# Tools
	# ===============================================
	# Get File Path (join rootdir + relativepath)
	proc getFilePath {id} {
		variable rootdir
		if {$rootdir == {}} {return {}}
		encoding system utf-8
		
		set listdata [db eval "select filepath from tFile where id = $id"]
		set rpath [lindex $listdata 0]

		# return relative path(default)
		if {[file exists [file join $rootdir $rpath]]} {
			db eval "update tFile set exists = 1 where id = $id"
			encoding system $::pref(encoding)
			return $rpath
		}

		# return next search path (relative path)
		set listdata [db eval "select value from tInfo where key = 'rootdir'"]
		set dbroot [lindex $listdata 0]
		if {[file exists [file join $dbroot $rpath]]} {
			db eval "update tFile set exists = 1 where id = $id"
			encoding system $::pref(encoding)
			return [::Util::getRelative $dbroot $rpath]
		}

		# return null(not found)
		db eval "update tFile set exists = 0 where id = $id"
		encoding system $::pref(encoding)
		return {}
	}
	
	# Get Preference Info
	proc getInfo {key} {
		variable db
		encoding system utf-8
		set val [lindex [db eval "select value from tInfo where key='$key'"] 0]
		encoding system $::pref(encoding)
		return $val
	}

	# Get Preference Info
	proc setInfo {key val} {
		variable db
		set exists [db eval "select count(value) from tInfo where key='$key'"]

		encoding system utf-8
		if {$exists==0} {
			db eval "insert into tInfo (key,value) values ('$key','$val')"
		} else {
			db eval "update tInfo set value='$val' where key='$key'"
		}
		encoding system $::pref(encoding)
	}

	# Check File Exists
	proc checkFileExists {} {
	}
	
	# Update Thumbnail And ImageInfo, Return new tkimage name.
	proc updateThumbnail {id} {
		set img [::Image::createThumbnail [getFilePath $id]]
		if {$img=={}} {
			updateItem $id [exists 0]
			return {}
		}
		updateItem $id [list \
			exists    1 \
			width     [lindex $img 0] \
			height    [lindex $img 1] \
			haveThumb 1 \
			thumb     [lindex $img 2] \
		]
		return [list id $id exists 1 width [lindex $img 0] height [lindex $img 1] tkimage [lindex $img 3] ]
	}
	
	# User Action to DB
	# ===============================================
	# Eval command .This proc should be used for Transaction Command.
	proc command {cmd} {
		variable db
		encoding system utf-8
		db eval $cmd
		encoding system $::pref(encoding)
	}
	
	# Label
	#------------------------------
	# update Label Name
	proc updateLabelName {labelid newname} {
		variable db
		encoding system utf-8
		set q "update tLabel set name='$newname' where id=$labelid"
		if {[catch {db eval $q}]} {
			encoding system $::pref(encoding)
			return 1
		}
		encoding system $::pref(encoding)
		return 0
	}
	
	# Return Cagerogy id and name list.
	proc getLabelList {} {
		variable db
		encoding system utf-8
		set q {select id, name from tLabel order by id}
		if {[catch {db eval $q} llist]} { 
			encoding system $::pref(encoding)
			return {}
		}
		encoding system $::pref(encoding)
		return $llist
	}
	
	# Category
	#------------------------------
	# add Category Name and Return its id
	proc addCategory {newname} {
		variable db
		encoding system utf-8
		set q "insert into tCategory (name) values ('$newname')"
		if {[catch {db eval $q}]} {
			encoding system $::pref(encoding)
			return {}
		}
		encoding system $::pref(encoding)
		return [db last_insert_rowid]
	}
	
	# update Category Name
	proc updateCategoryName {catid newname} {
		variable db
		encoding system utf-8
		set q "update tCategory set name='$newname' where id=$catid"
		if {[catch {db eval $q}]} {
			encoding system $::pref(encoding)
			return 1
		}
		encoding system $::pref(encoding)
		return 0
	}

	# delete Category 
	proc deleteCategory {catidlist} {
		variable db
		set q {delete from tCategory}
		append q [_createWhereID $catidlist]
		if {[catch {db eval $q}]} { return 1}
		return 0
	}
	
	# Return Cagerogy id and name list.
	proc getCategoryList {} {
		variable db
		encoding system utf-8
		set q {select id, name from tCategory}
		if {[catch {db eval $q} clist]} {
			encoding system $::pref(encoding)
			return {}
		}
		encoding system $::pref(encoding)
		return $clist
	}
	
	# Return Category name
	proc getCategoryName {catid} {
		variable db
		encoding system utf-8
		set q "select name from tCategory where id = $catid"
		if {[catch {db eval $q} ret]} {
			encoding system $::pref(encoding)
			return {}
		}
		encoding system $::pref(encoding)
		return $ret
	}
	
	# add Item to tItemCategory table
	proc addItemToCategory {idlist catlist} {
		variable db
		db eval {begin}
		foreach catid $catlist {
			foreach itemid $idlist {
				set q "insert into tItemCategory (itemid, catid) values ($itemid, $catid)"
				catch {db eval $q}
			}
		}
		db eval {commit}
		return 0
	}
	
	# delete Item from tItemCategory table
	proc deleteItemFromCategory {idlist catlist} {
		variable db
		if {[llength $catlist]==0} {
			db eval "delete from tItemCategory where itemid in ([join $idlist {,}])"
		} else {
			db eval "delete from tItemCategory where itemid in ([join $idlist {,}]) and catid in ([join $catlist {,}])"
		}
		return 0
	}
	
	# delete Category from tItemCategory table
	proc deleteCategoryFromItem {idlist catlist} {
		variable db
		if {[llength $idlist] == 0} {
			db eval "delete from tItemCategory where catid in ([join $catlist {,}])"
		} else {
			db eval "delete from tItemCategory where catid in ([join $catlist {,}]) and idlist in ([join $idlist {,}])"
		}
		return 0
	}

	# Return Item list from tItemCategory table
	proc getItemListFromCategory {catid} {
		variable db
		return [db eval "select itemid from tItemCategory where catid = $catid"]
	}

	# Return Category list from tItemCategory table
	proc getCategoryListFromItem {itemid} {
		variable db
		return [db eval "select catid from tItemCategory where itemid = $itemid"]
	}
	
	# Search
	#------------------------------
	# Return All Items ID List
	proc getAllID {} {
		variable db 
		return [db eval {select id from tFile order by id}]
	}
	
	# Search Item.and Return Found Item datalist.
	proc search {state} {
		set q [_parse $state]
		set listlist [list]
		encoding system utf-8

		db eval $q val {
			set category [db eval "select catid from tItemCategory where itemid=$val(id)"]
			set tkimage  [Image::addThumbnail $val(thumb)]
		 	lappend listlist [list \
			id			$val(id) \
			filepath	$val(filepath) \
			filename	$val(filename) \
			exists		$val(exists) \
			width		$val(width) \
			height		$val(height) \
			size		$val(size) \
			ctime		[clock scan $val(ctime)] \
			mtime		[clock scan $val(mtime)] \
			comment		$val(comment) \
			importance	$val(importance) \
			label		$val(label) \
			category	$category \
			tkimage		$tkimage \
			]
		}
		encoding system $::pref(encoding)
		return $listlist
	}
	
	# Parse state and return SQL Query
	proc _parse {state} {
		set q {select * from tFile }
		if {$state=={}} {return $q}
		# parse 
		set tlist [list]
		set where {where }
		set type {}
		set i 0
		foreach token $state {
			switch -- $token {
				and {set type and} AND {set type and} And {set type and}
				or  {set type or}  OR  {set type or}  Or  {set type or}
				not {set type not} NOT {set type not} Not {set type not}
				default {
					if {$type=={}} {set type and}
					set olist [_parseSearchKeyword $token]
					if {$i>0} { append where " $type " }
					append where { } [eval "_createWhere $olist"]
					set type {}
				}
			}
			incr i
		}
		return "$q $where"
	}
	
	# Parse and Return list {operator keyword value}
	proc _parseSearchKeyword {token} {
		
		if {[string match -nocase *>=* $token]} {
			set tlist [regexp -inline -- {(.*)>=(.*)} $token]
			return [concat >= [lrange $tlist 1 end]]

		} elseif {[string match -nocase *<=* $token]} {
			set tlist [regexp -inline -- {(.*)<=(.*)} $token]
			return [concat <= [lrange $tlist 1 end]]

		} elseif {[string match -nocase *=* $token]} {
			set tlist [regexp -inline -- {(.*)=(.*)} $token]
			if {[regexp -- {%|_} $token] != 0} {
				set operator {like}
			} else {
				set operator {=}
			}
			return [concat $operator [lrange $tlist 1 end]]

		} elseif {[string match -nocase *<* $token]} {
			set tlist [regexp -inline -- {(.*)<(.*)} $token]
			return [concat < [lrange $tlist 1 end]]

		} elseif {[string match -nocase *>* $token]} {
			set tlist [regexp -inline -- {(.*)>(.*)} $token]
			return [concat > [lrange $tlist 1 end]]

		} else {
			return [list {} $token {}]
		}
	}
	
	# create where state from idlist
	proc _createWhereID {idlist} {
		return " where id in ( [join $idlist {,}] )"
	}

	# create part of where state from key-value
	proc _createWhere {operator key value} {

		switch -- $key {
			id			{return " id $operator $value"}
			filepath	{return " filepath $operator '$value'"}
			filename	{return " filename $operator '$value'"}
			exists		{return " exists $operator $value"}
			width		{return " width $operator $value"}
			height		{return " height $operator $value"}
			size		{return " size $operator $value"}
			atime		{return " atime $operator '$value'"}
			ctime		{return " ctime $operator '$value'"}
			mtime		{return " mtime $operator '$value'"}
			comment		{return " comment $operator '$value'"}
			importance	{return " importance $operator $value"}
			label		{
				if {[regexp -- {^[0-9]$} $value]} {
					return " label $operator $value"
				} else {
					return " (label in (select id from tLabel where name $operator '$value'))"
				}
			}
			category    {
				return "id in (select tItemCategory.itemid from tItemCategory, tCategory 
				where tItemCategory.catid = tCategory.id and tCategory.name $operator '$value')"
			}
			default {
				return "( filepath like '%$key%' OR filename like '%$key%' OR comment like '%$key%' OR [_createWhere like label %$key%] OR [_createWhere like category %$key%] )"
			}
		}
	}

	# Check value type and if data type is text, return quoted string
	proc _quoteText {key value} {
		variable rootdir
		if {$key=={category}} {
			return $value
		}
		switch -- $key {
			id			{return $value}
			filepath	{return '[::Util::getRelative $rootdir $value]'}
			filename	{return '$value'}
			exists		{return $value}
			width		{return $value}
			height		{return $value}
			size		{return $value}
			atime		{return '$value'}
			ctime		{return '$value'}
			mtime		{return '$value'}
			comment		{return '$value'}
			category    {return $value}
			importance	{
				if {$value<0 || $value>9 || $value=={}} {set value 0}
				return $value
			}
			label		{
				if {$value<0 || $value>9 || $value=={}} {set value 0}
				return $value
			}
			haveThumb   {return $value}
			thumb       {return '$value'}
		}
	}
	
	# Item
	#------------------------------
	# add Item and return Item
	proc addItem {file} {
		variable db
		variable rootdir
		variable ftype
		encoding system utf-8

		set rpath   [::Util::getRelative $rootdir $file]
		if {[db eval "select count() from tFile where filepath = '$rpath'"] != 0 } {
			encoding system $::pref(encoding)
			return {}
		}
		
		set imginfo [::Image::createThumbnail $rpath]
		file stat $rpath finfo
		# File Info
		set filepath   $rpath
		set filename   [file tail $rpath]
		set exists     [file exists $file]
		set width      [lindex $imginfo 0]
		set height     [lindex $imginfo 1]
		set size       $finfo(size)
		set atime      [clock format $finfo(atime) -format {%Y-%m-%d %H:%M:%S}]
		set ctime      [clock format $finfo(ctime) -format {%Y-%m-%d %H:%M:%S}]
		set mtime      [clock format $finfo(mtime) -format {%Y-%m-%d %H:%M:%S}]
		set comment    {};# Now not use
		set importance 0
		set label      0
		set category   {};# Now not use
		set thumb      [lindex $imginfo 2]
		set haveThumb  [expr [string length $thumb]>0 ? 1:0]
		if {[catch {db eval "insert into tFile (filepath,filename,exists,width,height,size,atime,ctime,mtime,haveThumb,thumb) values ('$filepath','$filename',$exists,$width,$height,$size,'$atime','$ctime','$mtime',$haveThumb,'$thumb')"} msg]} {
#            tk_messageBox -message $msg
			encoding system $::pref(encoding)
			return {}
		}
		set lastrow [db last_insert_rowid]
		set id [db eval "select id from tFile where rowid = $lastrow"]

		encoding system $::pref(encoding)
		return [list \
			id			$id \
			filepath	$filepath \
			filename	$filename \
			exists		$exists \
			width		$width \
			height		$height \
			size		$size \
			ctime		$finfo(ctime) \
			mtime		$finfo(mtime) \
			comment		$comment \
			importance	$importance \
			label		$label \
			category	$category \
			tkimage		[lindex $imginfo 3]
		]
	}

	# update Item.
	proc updateItem {idlist optlist} {
		variable db
		set q {update tFile set }
		set i 0
		foreach {col val} $optlist {
			switch -- $col {
				category {
					deleteItemFromCategory $idlist {}
					addItemToCategory $idlist $val
				}
				default  {
					if {$i>0} {append q { , }}
					append q " $col = [_quoteText $col $val]"
					incr i
				}
			}
		}
		append q [_createWhereID $idlist]
		
		encoding system utf-8
		if {[catch {db eval $q} msg]} {
			encoding system $::pref(encoding)
			tk_messageBox -message $msg\n\n$q
			return 1
		}
		encoding system $::pref(encoding)
		return 0
	}
	
	# delete Item
	proc deleteItem {idlist} {
		variable db
		set q {delete from tFile}
		append q [_createWhereID $idlist]
		if {[catch {db eval $q} msg]} {
			tk_messageBox -message $msg\n\n$q
			return 1
		}
		deleteItemFromCategory $idlist {}
		return 0
	}
	
	# getItem
	proc getItem {id} {
		variable db
		encoding system utf-8

		set item [list]
		db eval "select * from tFile where id = $id" val {
			set item [list \
				id			$val(id) \
				filepath	$val(filepath) \
				filename	$val(filename) \
				exists		$val(exists) \
				width		$val(width) \
				height		$val(height) \
				size		$val(size) \
				ctime		[clock scan $val(ctime)] \
				mtime		[clock scan $val(mtime)] \
				comment		$val(comment) \
				importance	$val(importance) \
				label		$val(label) \
				category [db eval "select catid from tItemCategory where itemid=$val(id)"] \
				tkimage		[Image::addThumbnail $val(thumb)]
			]
		}
		encoding system $::pref(encoding)
		return $item
	}

	# getItemData. use like getData [list 1 2] [list filename size width height]
	proc getData {id collist} {
		variable db
		encoding system utf-8

		set datalist [list]
		foreach key $collist {
			switch -- $key {
				tkimage {
					set val [db eval "select thumb from tFile where id=$id"]
					lappend [Image::addThumbnail $val]
				}
				category {
					lappend datalist category \
					[db eval "select catid from tItemCategory where itemid=$id"]
				}
				default {
					set val [db eval "select $key from tFile where id = $id"]
					if {$key=={mtime} || $key=={ctime} || $key=={atime}} {
						set val [clock scan $val]
					}
					lappend datalist $key $val
				}
			}
		}
		encoding system $::pref(encoding)
		return $datalist
	}
	
	# Return Thumbnail Base64 encoded Jpeg
	proc getThumb {id} {
		variable db
		set t [db eval "select haveThumb,thumb from tFile where id = $id"]
		if {[lindex $t 0]==0} {
			return {}
		} else {
			return [lindex $t 1]
		}
	}

}

namespace eval Image {
	variable thum_size    80
	variable thum_quality 50
	variable name_thum ::img::thum
	#Return base64encoded thumbnail, width, height and tkimagename
	proc createThumbnail {file} {
		variable thum_size
		variable thum_quality
		variable name_thum

		# Get Unique Name of tkimage
		set i 0
		while { ![catch {image inuse ::img::thum$i}] } {incr i}
		set imgname $name_thum$i
		
		set wand [::magick create wand]
		set img [image create photo $imgname]
		if {[catch {$wand ReadImage $file}]} {
			return {}
		}
		set w [$wand GetWidth]
		set h [$wand GetHeight]

		set n [expr ($w>$h ? $w:$h) / ($thum_size * 1.0)]
		set nw [expr round($w/$n)] 
		set nh [expr round($h/$n)]
		$wand resize $nw $nh
		magicktophoto $wand $img
		::magick delete $wand
		return [list $w $h \
		[$img data -format [list jpeg -optimize -quality $thum_quality]] \
		$img \
		]
		
	}
	
	# create new Tkimage and return Tkimage name
	proc addThumbnail {data} {
		variable name_thum

		# Get Unique Name of tkimage
		set i 0
		while { ![catch {image inuse ::img::thum$i}] } {incr i}
		set imgname $name_thum$i
		set img [image create photo $imgname -data $data -format {jpeg}]
		return $img
	}

	# Read File and Resize Image and Return TkImgname for Prev
	# if w=-1 or h=-1 then auto resize. if z is set, resize.
	# Example  Default 640x480
	# w=320, h=320, z=-1-> 320x240
	# w=-1,  h=-1,  z=  -> 640x480(noresize)  w=-1,  h=-1,  z=1.5 -> 960x720
	# w=320, h=-1,  z=1 -> 320x240            w=320, h=-1,  z=1.5 -> 480x360
	# w=320, h=100, z=1 -> 320x100            w=320, h=100, z=1.5 -> 480x150
	proc getPrevImg {file w h {z 1}} {
		vacuum
		set wand [::magick create wand]
		if {[catch {$wand ReadImage $file}]} { return {} }
		set imgw [$wand GetWidth]
		set imgh [$wand GetHeight]
		# Resize
		if {$w!=-1 || $h!=-1 || $z!=1} {
			set ow [$wand GetWidth]
			set oh [$wand GetHeight]
			if {$w<=0 && $h<=0} {
				set nw $ow
				set nh $oh
			} elseif {$w<=0 && $h>0} {
				set nw [expr $ow * ($h/($oh*1.0))]
				set nh $h
			} elseif {$w>0 && $h<=0} {
				set nh [expr $oh * ($w/($ow*1.0))]
				set nw $w
			} else {
				set nw $w
				set nh $h
			}

			if {$z<=0} {
				if {[expr $ow/($oh*1.0)] > [expr $nw/($nh*1.0)]} {
					set n [expr $nw/($ow*1.0)]
				} else {
					set n [expr $nh/($oh*1.0)]
				}
				set nw [expr $ow*$n]
				set nh [expr $oh*$n]
				set z 1
			}

			set nw [expr round($nw*$z)] 
			set nh [expr round($nh*$z)]
			$wand resize $nw $nh
		}
		
		set img [image create photo]
		magicktophoto $wand $img
		::magick delete $wand
		return $img
	}
	
	# Delete Unused TkImages
	proc vacuum {} {
		variable name_thum
		foreach img [image names] {
			if {![image inuse $img]} {
				image delete $img
			}
		}
	}

}

namespace eval Prev {
	variable cnv     {}
	variable type    {};# {actual} {fit_auto}, {fit_x}, {fit_y}, {zoom 1.0}
	set type {actual}
	variable drag
	array set drag {}
	set drag(stpoint)	[list]
	set drag(xenable)	0;# 1=on 0=off
	set drag(yenable)	0;# 1=on 0=off
	
	variable pref
	array set pref {
		scrollinc   2
		bgcolor     #000000
		cursor      fleur
		id          {}
	}
	variable tag
	array set tag {
		img		img
	}

	# init 
	proc init {canvas} {
		variable cnv
		variable pref
		variable tag
		set cnv $canvas
		$cnv configure -bg $pref(bgcolor) -cursor $pref(cursor) \
			-highlightthickness 0 \
			-xscrollincrement $pref(scrollinc) \
			-yscrollincrement $pref(scrollinc)
		$cnv create image 0 0 -anchor c -tag $tag(img)
	}

	# init popup
	proc initPopMenu {menu} {
		$menu add radiobutton -label [mc ActualSize] -value actual
		$menu add radiobutton -label [mc FitAuto]    -value fit_auto
		$menu add radiobutton -label [mc FitWidth]   -value fit_x
		$menu add radiobutton -label [mc FitHeight]  -value fit_y
		$menu add separator
		$menu add radiobutton -label [mc 13%]  -value {zoom 0.125}
		$menu add radiobutton -label [mc 25%]  -value {zoom 0.25}
		$menu add radiobutton -label [mc 50%]  -value {zoom 0.5}
		$menu add radiobutton -label [mc 100%] -value {zoom 1}
		$menu add radiobutton -label [mc 200%] -value {zoom 2}
		$menu add radiobutton -label [mc 400%] -value {zoom 4}
		$menu add radiobutton -label [mc 800%] -value {zoom 8}
		for {set i 0} {$i<=[$menu index end]} {incr i} {
			set type [$menu type $i]
			if {$type!={tearoff} && $type!={separator}} {
				$menu entryconfigure $i -variable ::Prev::type
			}
		}
		trace add variable ::Prev::type {write} {::Prev::setImage;#}
	}

	# set image
	proc setImage {} {
		variable cnv
		variable tag
		variable pref
		variable type
		variable drag
		
		if {$pref(id)=={}} {return}
		set file [::DB::getFilePath $pref(id)]

		$cnv itemconfigure $tag(img) -image {}
		update
		set cw [winfo width $cnv]
		set ch [winfo height $cnv]
		switch -- [lindex $type 0] {
			actual   {set x  -1; set y  -1; set z 1}
			fit_x    {set x $cw; set y  -1; set z 1}
			fit_y    {set x  -1; set y $ch; set z 1}
			fit_auto {set x $cw; set y $ch; set z -1}
			zoom     {set x -1; set y -1; set z [lindex $type 1]}
			default  {set x -1; set y -1; set z 1}
		}
		set img [::Image::getPrevImg $file $x $y $z]
		$cnv itemconfigure $tag(img) -image $img
		$cnv configure -scrollregion [$cnv bbox all]
		# Move Image to Center
		set x [$cnv canvasx [expr [winfo width $cnv]/2.0]]
		set y [$cnv canvasy [expr [winfo height $cnv]/2.0]]
		$cnv xview scroll [expr -int($x/[$cnv cget -xscrollincrement])] units
		$cnv yview scroll [expr -int($y/[$cnv cget -yscrollincrement])] units
		# Set drag Enable
		foreach {lx ly rx ry} [$cnv bbox all] {
			set drag(xenable) [expr ($rx - $lx) > [winfo width $cnv]  ? 1:0]
			set drag(yenable) [expr ($ry - $ly) > [winfo height $cnv] ? 1:0]
		}
	}

	# clear image
	proc clear {} {
		variable cnv
		variable tag
		variable pref
		set pref(id)   {}
		$cnv itemconfigure $tag(img) -image {}
		$cnv configure -scrollregion [$cnv bbox all]
	}

	
	# Mouse Dragging
	# ============================================
	# Start of scroll Image by dragging
	proc dragStart {x y} {
		variable cnv
		variable drag
		set drag(stpoint) [list $x $y]
	}
	
	# Mouse Moving in Dragging
	proc dragMove {x y} {
		variable cnv
		variable tag
		variable drag
		variable pref
		if {$pref(id)=={}} {return}
		
		set xm [expr ([lindex $drag(stpoint) 0]-$x) ]
		set ym [expr ([lindex $drag(stpoint) 1]-$y) ]
		
		if {[expr abs($xm)] > $pref(scrollinc) && $drag(xenable)} {
			$cnv xview scroll [expr $xm/$pref(scrollinc)] units
			set drag(stpoint) [lreplace $drag(stpoint) 0 0 $x]
		}
		if {[expr abs($ym)] > $pref(scrollinc) && $drag(yenable)} {
			$cnv yview scroll [expr $ym/$pref(scrollinc)] units
			set drag(stpoint) [lreplace $drag(stpoint) 1 1 $y]
		}
	}

}

namespace eval ThumList {
	variable color
	array set color {
		list_border     #332222
		list_base       #000000
		thum_base       #332222
		thum_outline    #221111
		thum_shadow     #201515
	}
	variable label
	array set label {} 
	#list is {LabelText TextColor SelectedTextColor BGColor SelectedBGColor}
	set label(0)    [list [mc None]    #FFFFFF #000000 #000000 #FFDC5A]
	set label(1)    [list [mc Label1]  #FF0000 #000000 #000000 #FFDC5A]
	set label(2)    [list [mc Label2]  #FFFF00 #000000 #000000 #FFDC5A]
	set label(3)    [list [mc Label3]  #999999 #000000 #000000 #FFDC5A]
	set label(4)    [list [mc Label4]  #0000FF #000000 #000000 #FFDC5A]
	set label(5)    [list [mc Label5]  #006666 #000000 #000000 #FFDC5A]
	set label(6)    [list [mc Label6]  #440044 #000000 #000000 #FFDC5A]
	set label(7)    [list [mc Label7]  #0055AA #000000 #000000 #FFDC5A]
	set label(8)    [list [mc Label8]  #1100FF #000000 #000000 #FFDC5A]
	set label(9)    [list [mc Label9]  #00aacc #000000 #000000 #FFDC5A]
	variable category
	array set category {}
	variable stylename
	array set stylename {
		list  {LIST-STYLE}
		thum  {THUM-STYLE}
	}
	variable colview
	array set colview {
		thumbnail  1
		id         0
		filepath   0
		filename   1
		type       1
		exists     0
		width      1
		height     1
		size       1
		ctime      0
		mtime      1
		importance 1
		label      1
		category   1
		comment    1
	}

	variable tree       {}
	variable sort_status     [list 1 {-increasing}] ;#colnum sortoption
	variable pref
	array set pref {}
	set pref(list_padx)  4
	set pref(timeformat) %c
	
	# Clear All Data (Label Category)
	proc clear {} {
		variable tree
		variable label
		variable category
		
		array set category {}
		deleteItem [getAll]
	
	}

	# Init tree. Create Style and set Data
	proc init {treectrl} {
		variable color
		variable label
		variable stylename
		variable pref
		variable tree
		set tree $treectrl
		# Element for Thumbnail Image
		$tree element create eImg image \
			-width $::Image::thum_size -height $::Image::thum_size
        
		foreach {n labellist} [array get label] {
			set labelname [lindex $labellist 0]
			set colfg_def [lindex $labellist 1]
			set colfg_sel [lindex $labellist 2]
			set colbg_def [lindex $labellist 3]
			set colbg_sel [lindex $labellist 4]
			# Thumbnail Style
			# --------------------------------------
			# Create Element
			$tree element create eName$n text -lines 1 -width $::Image::thum_size 
			$tree element create eRect$n rect -outlinewidth 1
			$tree element create eShadow$n rect -outlinewidth 1 -open wn
			# Create Style
			set S [$tree style create $stylename(thum)$n -orient vertical]
			$tree style elements $S [list eShadow$n eRect$n eImg eName$n]
			# Layout Style
			$tree style layout $S eShadow$n -detach yes -padx {1 2} -pady {1 2} -iexpand es
			$tree style layout $S eImg -pady {0 1}
			$tree style layout $S eName$n -expand we -ipady {0 2} -padx {0 3} -squeeze x
			$tree style layout $S eRect$n -union [list eImg eName$n] \
				-ipadx 6 -padx {0 3} -pady {0 3} 
			# Color
			$tree element configure eName$n -fill [list $colfg_sel {selected} $colfg_def {}]
			$tree element configure eRect$n -fill [list $colbg_sel {selected} $colbg_def {}] \
				-outline $color(thum_outline)
			$tree element configure eShadow$n -outline $color(thum_shadow)
			
			# ListTable Style
			# --------------------------------------
			# Create Element
			$tree element create eText$n text -lines 1 
			$tree element create eBorder$n rect -open nw -outlinewidth 1
			# Create Style
			set S [$tree style create $stylename(list)$n -orient horizontal]
			$tree style elements $S [list eBorder$n eText$n]
			# Layout Style
			$tree style layout $S eBorder$n -detach yes -iexpand es
			$tree style layout $S eText$n -expand ns -squeeze x -padx $pref(list_padx)
			# Color
			$tree element configure eText$n -fill [list $colfg_sel {selected} $colfg_def {}]
			$tree element configure eBorder$n -fill [list $colbg_sel {selected} $colbg_def {}] \
				-outline $color(list_border) 
			
		}
		
		# Set Column Configure
		$tree column configure  0 -tag thumbnail
		$tree column configure  1 -tag id         -text [mc ID] -justify right
		$tree column configure  2 -tag filepath   -text [mc FilePath]
		$tree column configure  3 -tag filename   -text [mc FileName]
		$tree column configure  4 -tag type       -text [mc Type]
		$tree column configure  5 -tag exists     -text [mc Exists] -justify right
		$tree column configure  6 -tag width      -text [mc Width]  -justify right
		$tree column configure  7 -tag height     -text [mc Height] -justify right
		$tree column configure  8 -tag size       -text [mc Size]   -justify right
		$tree column configure  9 -tag ctime      -text [mc CreatedDate]
		$tree column configure 10 -tag mtime      -text [mc ModifiedDate]
		$tree column configure 11 -tag importance -text [mc Importance] -justify right
		$tree column configure 12 -tag label      -text [mc Label]
		$tree column configure 13 -tag category   -text [mc Category]
		$tree column configure 14 -tag comment    -text [mc Comment]
		
	}

	# Init Header Popup Menu for column view/hide
	proc initHeaderPopMenu {menu} {
		$menu add checkbutton -label [mc ID]            -variable ::ThumList::colview(id)
		$menu add checkbutton -label [mc FilePath]     -variable ::ThumList::colview(filepath)
		$menu add checkbutton -label [mc FileName]     -variable ::ThumList::colview(filename)
		$menu add checkbutton -label [mc Type]         -variable ::ThumList::colview(type)
		$menu add checkbutton -label [mc Width]        -variable ::ThumList::colview(width)
		$menu add checkbutton -label [mc Height]       -variable ::ThumList::colview(height)
		$menu add checkbutton -label [mc Size]         -variable ::ThumList::colview(size)
		$menu add checkbutton -label [mc CreatedDate]  -variable ::ThumList::colview(ctime)
		$menu add checkbutton -label [mc ModifiedDate] -variable ::ThumList::colview(mtime)
		$menu add checkbutton -label [mc Importance]   -variable ::ThumList::colview(importance)
		$menu add checkbutton -label [mc Label]        -variable ::ThumList::colview(label)
		$menu add checkbutton -label [mc Category]     -variable ::ThumList::colview(category)
		$menu add checkbutton -label [mc Comment]      -variable ::ThumList::colview(comment)
		for {set i 0} {$i<=[$menu index end]} {incr i} {
			set type [$menu type $i]
			if {$type!={tearoff} && $type!={separator}} {
				$menu entryconfigure $i -command {::ThumList::switchView list}
			}
		}
	}

	# Items add set get 
	# ===========================================

	# Return Item's data list from desc item.
	proc getItem {desc} {
		variable tree
		variable stylename
		array set item {}
		set n [getLabelNum $desc]
		set item(id)         [$tree item text $desc id]
		set item(filepath)   [$tree item text $desc filepath]
		set item(filename)   [$tree item text $desc filename]
		set item(exists)     [$tree item text $desc exists]
		set item(width)      [$tree item text $desc width]
		set item(height)     [$tree item text $desc height]
		set item(size)       [$tree item element cget $desc size eText$n -data]
		set item(ctime)      [$tree item element cget $desc ctime eText$n -data]
		set item(mtime)      [$tree item element cget $desc mtime eText$n -data]
		set item(comment)    [$tree item element cget $desc comment eText$n -data]
		set item(importance) [$tree item text $desc importance]
		set item(label)      [$tree item element cget $desc label eText$n -data]
		set item(category)   [$tree item element cget $desc category eText$n -data]
		set item(tkimage)    [$tree item element cget $desc thumbnail eImg -image]
		return [array get item]
	}

	# Return Item Colmn data. coltag is column tag name.
	proc getData {desc coltag} {
		variable tree
		set n [getLabelNum $desc]
		switch -- $coltag {
			id       {return [$tree item text $desc id]}
			filepath {return [$tree item text $desc filepath]}
			filename {return [$tree item text $desc filename]}
			exists   {return [$tree item text $desc exists]}
			width    {return [$tree item text $desc width]}
			height   {return [$tree item text $desc height]}
			size     {return [$tree item element cget $desc size eText$n -data] }
			ctime    {return [$tree item element cget $desc ctime eText$n -data] }
			mtime    {return [$tree item element cget $desc mtime eText$n -data] }
			comment  {return [$tree item element cget $desc comment eText$n -data] }
			importance {return [$tree item text $desc importance]}
			label    {return $n }
			category {return [$tree item element cget $desc category eText$n -data] }
			tkimage  {return [$tree item element cget $desc thumbnail eImg -image]}
		}
	}

	# Set Item's all data to desc item.
	proc setItem {desc listdata} {
		setData $desc $listdata
	}

	# Set Item's data to desc item
	proc setData {desc colvallist} {
		variable tree
		variable pref
		foreach {col val} $colvallist {
			switch -- $col {
				id       {$tree item text $desc id $val}
				filepath {$tree item text $desc filepath $val}
				filename {
					set n [getLabelNum $desc]
					$tree item text $desc filename $val
					$tree item element configure $desc thumbnail eName$n -text $val
					set type [string toup [string trim [file ext $val] .]]
					if {$type=={}} {set type { }};# if NULL, sort will clash.
					$tree item text $desc type $type
				}
				exists   {$tree item text $desc exists $val}
				width    {$tree item text $desc width $val}
				height   {$tree item text $desc height $val}
				size     {
					set n [getLabelNum $desc]
					$tree item element configure $desc size eText$n -data $val
					$tree item element configure $desc size eText$n -text "[expr $val/1024] KB"
				}
				ctime    {
					set n [getLabelNum $desc]
					$tree item element configure $desc ctime eText$n -data $val
					$tree item element configure $desc ctime eText$n \
						-text [clock format $val -format $pref(timeformat)]
				}
				mtime    {
					set n [getLabelNum $desc]
					$tree item element configure $desc mtime eText$n -data $val
					$tree item element configure $desc mtime eText$n \
						-text [clock format $val -format $pref(timeformat)]
				}
				comment  {
					set n [getLabelNum $desc]
					$tree item element configure $desc comment eText$n -data $val
					if {$val == {} } {set $val { }};# if NULL, sort will clash.
					$tree item element configure $desc comment eText$n -text $val
				}
				importance {$tree item text $desc importance $val}
				label    {changeStyle $desc $val}
				category {
					set n [getLabelNum $desc]
					$tree item element configure $desc category eText$n -data $val
					if {$val == {} } {
						set cat { };# if NULL, sort will clash.
					} else {
						set cat {}
						set i 0
						foreach num $val {
							if {$i>0} {append cat { / }}
							append cat "[getCategoryName $num]"
							incr i
						}
					}
					$tree item element configure $desc category eText$n -text $cat
				}
				tkimage  {$tree item element configure $desc thumbnail eImg -image $val}
			}
		}
	}

	# Set Style (Label) to desc. 
	# Note: desc data will be lost! if you want to change to other Style, 
	# you can use changeStyle proc that is map old styledata to new styledata.
	proc setStyle {desc labelnum} {
		variable tree
		variable stylename
		set n $labelnum
		
		# Set for Thumbnail View
		$tree item style set $desc thumbnail  $stylename(thum)$n
		# Set for TableList View
		$tree item style set $desc id         $stylename(list)$n
		$tree item style set $desc filepath   $stylename(list)$n
		$tree item style set $desc filename   $stylename(list)$n
		$tree item style set $desc type       $stylename(list)$n
		$tree item style set $desc exists     $stylename(list)$n
		$tree item style set $desc width      $stylename(list)$n
		$tree item style set $desc height     $stylename(list)$n
		$tree item style set $desc size       $stylename(list)$n
		$tree item style set $desc ctime      $stylename(list)$n
		$tree item style set $desc mtime      $stylename(list)$n
		$tree item style set $desc comment    $stylename(list)$n
		$tree item style set $desc importance $stylename(list)$n
		$tree item style set $desc label      $stylename(list)$n
		$tree item style set $desc category   $stylename(list)$n
	}

	# Create new item. and set data
	proc addItem {listdata} {
		variable tree
		array set item $listdata
		set desc [$tree item create]
		setStyle $desc $item(label)
		setItem $desc $listdata
		$tree item lastchild root $desc
		array unset item
	}
	
	# delete Item
	proc deleteItem {desclist} {
		variable tree
		foreach desc $desclist {
			# Doesn't item delete command release tkimage? inuse flug is 1.
			# So we must force to delete tkimage.
			set tkimage [$tree item element cget $desc thumbnail eImg -image]
			$tree item delete $desc
			image delete $tkimage
		}
	}

	# change Style
	proc changeStyle {desc labelnum} {
		variable tree
		variable stylename
		set on [getLabelNum $desc] ;# Old Label Number
		set nn $labelnum           ;# New Label Number
		set thummap [list eImg eImg eName$on eName$nn eRect$on eRect$nn eShadow$on eShadow$nn]
		set listmap [list eText$on eText$nn eBorder$on eBorder$nn]
		$tree item style map $desc thumbnail  $stylename(thum)$nn $thummap
		$tree item style map $desc id         $stylename(list)$nn $listmap
		$tree item style map $desc filepath   $stylename(list)$nn $listmap
		$tree item style map $desc filename   $stylename(list)$nn $listmap
		$tree item style map $desc type       $stylename(list)$nn $listmap
		$tree item style map $desc exists     $stylename(list)$nn $listmap
		$tree item style map $desc width      $stylename(list)$nn $listmap
		$tree item style map $desc height     $stylename(list)$nn $listmap
		$tree item style map $desc size       $stylename(list)$nn $listmap
		$tree item style map $desc ctime      $stylename(list)$nn $listmap
		$tree item style map $desc mtime      $stylename(list)$nn $listmap
		$tree item style map $desc comment    $stylename(list)$nn $listmap
		$tree item style map $desc importance $stylename(list)$nn $listmap
		$tree item style map $desc label      $stylename(list)$nn $listmap
		$tree item style map $desc category   $stylename(list)$nn $listmap
		# change Label Text
		$tree item element configure $desc label eText$nn -data $nn
		$tree item element configure $desc label eText$nn -text [getLabelName $nn]
	}
	
	# update Item
	proc updateItem {desclist optlist} {
		foreach desc $desclist {
			setData $desc $optlist
		}
	}
	
	# Return Item Number from DatabaseID
	proc getDesc {id} {
		variable tree
		set desclist [getAll]
		foreach desc [$tree item children root] {
			if {$id == [getID $desc]} {
				return $desc
			}
		}
		return {}
	}

	# Return next Desc from Desc
	proc getNextDesc {desc} {
		variable tree
		set desclist [$tree item children root]
		set index [lindex [$tree item index $desc] 1]
		if {$index < [expr [llength $desclist] -1]} {
			incr index
		} 
		return [lindex $desclist $index]
	}

	# Return preview Desc from Desc
	proc getPrevDesc {desc} {
		variable tree
		set desclist [$tree item children root]
		set index [lindex [$tree item index $desc] 1]
		if {$index > 0} {
			incr index -1
		} 
		return [lindex $desclist $index]
	}

	# Return TreeCtrls Item Desc List
	proc getAll {} {
		variable tree
		return [$tree item children root]
	}
	
	# Return Selected Item Desc List
	proc getSelected {} {
		variable tree
		return [$tree selection get]
	}

	# Return DatabaseID from Item Description
	proc getID {desc} {
		variable tree
		set style [$tree item style elements $desc id]
		return [$tree item element cget $desc id $style -text]
	}
	
	# Return All Items ID List
	proc getAllID {} {
		variable tree
		set desclist [$tree item children root]
		set idlist [list]
		foreach desc $desclist {
			lappend idlist [getID $desc]
		}
		return $idlist
	}
	
	# Label
	# ==========================================
	# Return Label(Style) Number
	proc getLabelNum {desc} {
		variable tree
		set style [$tree item style set $desc label]
		regsub {[^\d]*} $style {} n
		return $n
	}

	# Set Label Name
	proc setLabelName {itemlist} {
		variable label
		foreach {key val} $itemlist {
			lset label($key) 0 $val
		}
	}

	# Return Label Name
	proc getLabelName {labelnum} {
		variable label
		return [lindex $label($labelnum) 0]
	}

	# Category
	# ==========================================
	# Return Category ID Name List
	proc getCategoryList {} {
		variable category
		set clist [list]
		foreach {id name} [array get category] {
			lappend clist [list $id $name]
		}
		return [eval "concat [concat [lsort -index 0 $clist]]"]
	}
	
	# Clear Category ID Name List
	proc clearCategory {} {
		variable category
		foreach key [array names category] {
			unset category($key)
		}
	}
	
	# Return Category Name
	proc getCategoryName {catnum} {
		variable category
		if {[array names category $catnum]=={}} {
			return $catnum
		} else {
			return $category($catnum)
		}
	}
	
	# Set Category Name
	proc setCategoryName {listitem} {
		variable category
		foreach {num name} $listitem {
			set category($num) $name
		}
	}

	# Utility
	# ==========================================
	# Change Color and Thumbnail Size
	proc updateStyle {} {
		variable color
		variable label
		variable tree
		variable stylename
		
		$tree element configure eImg -width $::Image::thum_size -height $::Image::thum_size
		foreach {n labellist} [array get label] {
#            set labelname [lindex $labellist 0]
			set colfg_def [lindex $labellist 1]
			set colfg_sel [lindex $labellist 2]
			set colbg_def [lindex $labellist 3]
			set colbg_sel [lindex $labellist 4]
			# Thumbnail
			$tree element configure eName$n -fill [list $colfg_sel {selected} $colfg_def {}] \
				-width $::Image::thum_size
			$tree element configure eRect$n -fill [list $colbg_sel {selected} $colbg_def {}] \
				-outline $color(thum_outline)
			$tree element configure eShadow$n -outline $color(thum_shadow)
			# ListTable
			# Color
			$tree element configure eText$n -fill [list $colfg_sel {selected} $colfg_def {}]
			$tree element configure eBorder$n -fill [list $colbg_sel {selected} $colbg_def {}] \
				-outline $color(list_border) 
		}
		update
	}

	# Get Infomation Summary String
	proc getInfoString {desc format} {
		if {$desc=={}} return {}

		set item [getItem $desc]
		foreach {key val} $item {set $key $val}
		set label [getLabelName $label]
		set cmd {set ret }
		append cmd  \"$format\"
		eval $cmd
		return $ret
	}
	
	# Switch Thumbnail View <-> ListTable View type 1=Thumb 2=TableList
	proc switchView {type} {
		variable tree
		variable color
		variable colview
		switch -- $type {
			thum {
			# Thumbnail View
				$tree configure \
				-showroot no -showbuttons no -showheade no -showlines no \
				-wrap window -orient horizontal \
				-bg $color(thum_base)
				
				set colview(thumbnail) 1
				$tree column configure thumbnail -visible 1
				foreach {col val} [array get colview] {
					if {$col=={thumbnail}} {continue}
					$tree column configure $col -visible 0
				}
			}

			list {
			# TableList View
				$tree configure \
				-showroot no -showbuttons yes -showheade yes -showlines no \
				-wrap {} -orient vertical \
				-bg $color(list_base)
				
				set colview(thumbnail) 0
				foreach {col val} [array get colview] {
					$tree column configure $col -visible $val
				}
				
			}
		}
	}

	# Set Selection 
	proc setSelection {desclist} {
		variable tree
		$tree selection clear
		if {$desclist=={}} {return}

		$tree selection modify $desclist {}
	}
	
	# select All Item
	proc setSelectionAll {} {
		variable tree
		set f [$tree item firstchild root]
		set l [$tree item lastchild root]
		$tree selection add $f $l
	}
	
	# invert Selection
	proc invertSelection {} {
		variable tree
		set slist [$tree selection get]
		setSelectionAll
		$tree selection modify {} $slist
	}

	# Sort List
	proc sort {col} {
		variable tree
		variable sort_status
		if {$col=={random}} {
			set desclist [getAll]
			set desclist [lsort -command "::Util::compareRand [llength $desclist]" $desclist]
			foreach desc $desclist {
				$tree item firstchild root $desc
			}
			
			set sort_status [list random {}]
			return
		}
		
		if {[lindex $sort_status 0] == $col} {
			if {[lindex $sort_status 1] == {-increasing}} {
				set sort_status [list $col -decreasing]
			} else {
				set sort_status [list $col -increasing]
			}
		} else {
			set sort_status [list $col -increasing]
		}
		$tree item sort root -column $col -dictionary [lindex $sort_status 1]
	}

}

namespace eval StatusBar {
	variable format {$label ($importance)  |  $width x $height  |  [expr $size/1024]KB  |  $filepath  |  exists:$exists }
	variable text   {}

}

namespace eval SearchBox {
	variable cmb {}       ;#Combobox
	variable statement {} ;#Statement
	
	proc init {combobox} {
		variable cmb
		set cmb $combobox
		$cmb configure -editable yes -textvariable ::SearchBox::statement
	}
	
	# add new History 
	proc addHistory {state} {
		variable cmb
		set history [$cmb cget -values]
		if {[lsearch $history $state]==-1} {
			$cmb configure -values [concat $state $history]
		}
	}
	
	# Clear History
	proc clearHistory {} {
		$cmb configure -values {}
	}

	# Return Statement
	proc getStatement {} {
		variable statement
		return $statement
	}

}

namespace eval SubWindow {
	namespace eval Rename {
		variable window .rename
		variable filelist
		variable result
		variable type
		array set type { name none num none ext none }
		variable detail
		array set detail {
			name_key {}
			name_rep {}
			ext	{}
			num_st	 0
			num_inc  1
			num_digit 3
		}
		
		# Show GUI
		proc show {files} {
			variable window
			variable filelist
			variable result
			set filelist $files
			set result {}
			toplevel $window

			# Command Buttons
			frame $window.f8 -border 10
			button $window.f8.ok     -width 13 -text [mc OK] \
				-command "
				set SubWindow::Rename::result \[SubWindow::Rename::do\] 
				destroy $window 
				"
			button $window.f8.test   -width 13 -text [mc Test] \
				-command "SubWindow::Rename::updateList $window.ftest.tree"
			button $window.f8.cancel -width 13 -text [mc Cancel] \
				-command "destroy $window"
			pack $window.f8.ok $window.f8.test $window.f8.cancel -side left -anchor c -padx 4
			pack $window.f8

			# TestResult ListTable
			set label0 $::ThumList::label(0)
			array set color [list \
				base   $::ThumList::color(list_base) \
				border $::ThumList::color(list_border) \
				str [lindex $label0 1]   str_sel [lindex $label0 2] \
				bg  [lindex $label0 3]   bg_sel  [lindex $label0 4] \
			]
			frame $window.ftest
			scrollbar $window.ftest.y -command "$window.ftest.tree yview"
			set T [treectrl $window.ftest.tree -yscrollcommand "$window.ftest.y set" \
				-showroot no -showbuttons no -showheade yes -showlines no -bg $color(base)]
			
			$T element create eText text -lines 1 \
				-fill [list $color(str_sel) {selected focus} $color(str) {}]
			$T element create eBorder rect -open nw -outlinewidth 1 \
				-fill [list $color(bg_sel) {selected focus} $color(bg) {}] -outline $color(border)
			
			set S [$T style create style0 -orient horizontal]
			$T style elements $S [list eBorder eText]
			$T style layout $S eBorder -detach yes -iexpand es
			$T style layout $S eText -expand ns -squeeze x -padx 4
			$T column configure 0 -tag before -width 150 -text [mc {Before changing}]
			$T column configure 1 -tag after  -width 150 -text [mc {After changing}]
			$T column configure 2 -tag state  -width  50 -text [mc Error]
			pack $window.ftest.y -side right -fill y
			pack $window.ftest.tree -expand yes -fill both
			pack $window.ftest -side bottom -expand yes -fill both

			# Name
			labelframe $window.fname -text [mc {Change Name}]
			radiobutton $window.fname.r0 -variable SubWindow::Rename::type(name) -value none -text [mc {Do Nothing}]
			radiobutton $window.fname.r1 -variable SubWindow::Rename::type(name) -value replace -text [mc {Regexp Replace}]
			radiobutton $window.fname.r2 -variable SubWindow::Rename::type(name) -value upper -text [mc {To Upper}]
			radiobutton $window.fname.r3 -variable SubWindow::Rename::type(name) -value lower -text [mc {To Lower}]
			radiobutton $window.fname.r4 -variable SubWindow::Rename::type(name) -value title -text [mc {To Title}]
			frame $window.fname.replace
			entry $window.fname.replace.e0 -width 10 -textvariable SubWindow::Rename::detail(name_key)
			entry $window.fname.replace.e1 -width 10 -textvariable SubWindow::Rename::detail(name_rep)
			label $window.fname.replace.arw -text {->}
			pack $window.fname.replace.e0 $window.fname.replace.arw $window.fname.replace.e1 -side left

			pack $window.fname.r0 -anchor w -side top
			pack $window.fname.r1 -anchor w -side top
			pack $window.fname.replace -anchor w -side top
			pack $window.fname.r2 $window.fname.r3 $window.fname.r4 -anchor w -side top
			pack $window.fname -side left -fill both -expand yes

			# Number
			labelframe $window.fnumber -text [mc {Add Number}]
			radiobutton $window.fnumber.r0 -variable SubWindow::Rename::type(num) -value none -text [mc {Do Nothing}]
			radiobutton $window.fnumber.r1 -variable SubWindow::Rename::type(num) -value number -text [mc {Add Number}]
			frame $window.fnumber.detail
			label $window.fnumber.detail.stl    -text [mc {Start Num}]
			label $window.fnumber.detail.incl   -text [mc {Increment}]
			label $window.fnumber.detail.digitl -text [mc {Digit}]
			spinbox $window.fnumber.detail.st -textvariable SubWindow::Rename::detail(num_st) -width 8 -from {0} -to {100000}
			spinbox $window.fnumber.detail.inc   -textvariable SubWindow::Rename::detail(num_inc) -width 8 -from 1 -to 10
			spinbox $window.fnumber.detail.digit -textvariable SubWindow::Rename::detail(num_digit) -width 8 -from 1 -to 10
			grid $window.fnumber.detail.stl   -column 0 -row 0 
			grid $window.fnumber.detail.st    -column 1 -row 0 
			grid $window.fnumber.detail.incl  -column 0 -row 1 
			grid $window.fnumber.detail.inc   -column 1 -row 1 
			grid $window.fnumber.detail.digitl -column 0 -row 2 
			grid $window.fnumber.detail.digit  -column 1 -row 2 
			
			pack $window.fnumber.r0 $window.fnumber.r1 $window.fnumber.detail -anchor w
			pack $window.fnumber -side left -fill both -expand yes
			
			# Extension
			labelframe $window.fext -text [mc {Change Extension}]
			radiobutton $window.fext.r0 -variable SubWindow::Rename::type(ext) -value none -text [mc {Do Nothing}]
			radiobutton $window.fext.r1 -variable SubWindow::Rename::type(ext) -value change -text [mc {Replace}]

			radiobutton $window.fext.r2 -variable SubWindow::Rename::type(ext) -value upper -text [mc {To Upper}]
			radiobutton $window.fext.r3 -variable SubWindow::Rename::type(ext) -value lower -text [mc {To Lower}]
			
			frame $window.fext.detail
			entry $window.fext.detail.e0 -width 10 -textvariable ::SubWindow::Rename::detail(ext)
			label $window.fext.detail.l -text {}
			pack $window.fext.detail.l $window.fext.detail.e0 -side left

			pack $window.fext.r0 $window.fext.r1 -anchor w
			pack $window.fext.detail -anchor w
			pack $window.fext.r2 $window.fext.r3 -anchor w
			pack $window.fext -side left -fill both -expand yes

			grab set $window
			update
			set w [winfo width $window]
			set h [winfo height $window]
			set x [expr ([winfo vrootwidth $window]  - $w)/2]
			set y [expr ([winfo vrootheight $window] - $h)/2]
			wm minsize $window $w $h
			wm geometry $window $w\x$h+$x+$y
			wm transient $window .
			wm deiconify $window
		}

		# Update Test Rename TreeCtrl
		proc updateList {tree} {
			set flist [do]
			foreach desc [$tree item children root] {
				$tree item remove $desc
			}
			set clist [list]
			foreach {before after} $flist {
				
				set desc [$tree item create]
				$tree item style set $desc 0 style0
				$tree item style set $desc 1 style0
				$tree item style set $desc 2 style0
				$tree item text $desc 0 $before
				$tree item text $desc 1 $after

				if {[lsearch $clist $after]==-1} {
					if {[file exists $after]} {
						$tree item text $desc 2 EXISTS
					} else {
						$tree item text $desc 2 OK
						lappend clist $after
					}
				} else {
					$tree item text $desc 2 SAME
				}

				$tree item lastchild root $desc
			}
		}

		# Return filenames
		proc do {} {
			variable filelist
			variable detail
			
			set i $detail(num_st)
			set retlist [list]
			foreach bfile $filelist {
				set dir   [file dir $bfile]
				set fname [file tail $bfile]
				set ext   [file ext $bfile]
				set name  $fname
				regsub $ext $fname {} name
				
				set afile [_modifyName $name][_modifyNumber $i][_modifyExt $ext]
				lappend retlist $bfile [file join $dir $afile]
				incr i $detail(num_inc)
			}
			return $retlist
		}
		
		# Return modified filename
		proc _modifyName {name} {
			variable type
			variable detail
			switch -- $type(name) {
				default {return $name}
				none {return $name}
				upper {return [string toupper $name]}
				lower {return [string tolower $name]}
				title {return [string totitle $name]}
				replace {
					if {$detail(name_key)=={}} {return $name}
					regsub -all -- $detail(name_key) $name $detail(name_rep) ret
					return $ret
				}
			}
		}
		
		# Return increment number
		proc _modifyNumber {num} {
			variable type
			variable detail
			switch -- $type(num) {
				default {return {}}
				none {return {}}
				number {
					set num [string trimleft $num 0]
					if {$num=={}} {set num 0}
					return [format %0$detail(num_digit)\d $num]
				}
			}
		}
		
		# Return modified extension
		proc _modifyExt {ext} {
			variable type
			variable detail
			switch -- $type(ext) {
				default {return $ext}
				none {return $ext}
				upper {return [string toupper $ext]}
				lower {return [string tolower $ext]}
				change {
					return .[string trimleft $detail(ext) {.}]
				}
			}
		}

	}

	namespace eval Comment {
		variable window .comment
		variable result {}
		variable setresult 0

		# Show GUI
		proc show {comment} {
			variable window
			variable result
			variable setresult
			toplevel $window
			set result {}
			set setresult 0

			# Buttons
			frame $window.btn -border 10
			button $window.btn.ok     -width 13 -text [mc OK] \
				-command "
				set SubWindow::Comment::result \[$window.text get 1.0 \"end -1 chars\" \]  
				set SubWindow::Comment::setresult 1
				destroy $window "
			button $window.btn.cancel -width 13 -text [mc Cancel] \
				-command "destroy $window"
			pack $window.btn.ok $window.btn.cancel -side left -anchor c -padx 4
			pack $window.btn -side bottom
			# Text Widgets
			text $window.text -width 60 -height 10
			pack $window.text -fill both -expand yes
			# Set Values
			$window.text insert 0.0 $comment
			
			grab set $window
			update
			set w [winfo width $window]
			set h [winfo height $window]
			set x [expr ([winfo vrootwidth $window]  - $w)/2]
			set y [expr ([winfo vrootheight $window] - $h)/2]
			wm minsize $window $w $h
			wm geometry $window $w\x$h+$x+$y
			wm transient $window .
			wm deiconify $window
		}
		
	}
	
	namespace eval Label {
		variable window .label
		variable result {}

		proc show {} {
			variable window
			variable result
			toplevel $window
			set result {}
			# Buttons
			frame $window.btn -border 10
			button $window.btn.ok     -width 13 -text [mc OK] \
				-command "
				set SubWindow::Label::result 1
				destroy $window "
			button $window.btn.cancel -width 13 -text [mc Cancel] \
				-command "destroy $window"
			pack $window.btn.ok $window.btn.cancel -side left -anchor c -padx 4
			pack $window.btn -side bottom
			# Category List
			listbox $window.list -yscrollcommand "$window.y set"
			scrollbar $window.y -orient vertical -command "$window.list yview"
			button $window.rename -width 13 -text [mc Rename] \
				-command "::SubWindow::Label::rename $window.list"
			pack $window.list -side left -expand yes -fill both
			pack $window.y -side left -fill y
			pack $window.rename -padx 4 -pady 4
			wm transient $window .
			# Set Value
			setVal $window.list

			grab set $window
			update
			set w [winfo width $window]
			set h [winfo height $window]
			set x [expr ([winfo vrootwidth $window]  - $w)/2]
			set y [expr ([winfo vrootheight $window] - $h)/2]
			wm minsize $window $w $h
			wm geometry $window $w\x$h+$x+$y
			wm transient $window .
			wm deiconify $window
		}
		
		proc setVal {lbox} {
			$lbox delete 0 end
			foreach {id name} [::DB::getLabelList] {
				$lbox insert end $name
			}
		}
		
		proc rename {lbox} {
			variable window
			set sel [$lbox curselection]
			if {$sel == {}} return
			SubWindow::InputString::show [$lbox get $sel]
			tkwait window $SubWindow::InputString::window
			if {$SubWindow::InputString::setresult != 1} {
				raise $window
				return
			}
			::DB::updateLabelName $sel $SubWindow::InputString::result
			setVal $lbox
		}

	}

	namespace eval Category {
		variable window .category
		variable result {}
		variable cat {}

		proc show {} {
			variable window
			variable result
			toplevel $window
			set result {}
			
			# Buttons
			frame $window.btn -border 10
			button $window.btn.ok     -width 13 -text [mc OK] \
				-command "
				set SubWindow::Category::result 1
				destroy $window "
			button $window.btn.cancel -width 13 -text [mc Cancel] \
				-command "destroy $window"
			pack $window.btn.ok $window.btn.cancel -side left -anchor c -padx 4
			pack $window.btn -side bottom
			# Category List
			listbox $window.list -yscrollcommand "$window.y set"
			scrollbar $window.y -orient vertical -command "$window.list yview"
			button $window.rename -width 13 -text [mc Rename] \
				-command "::SubWindow::Category::rename $window.list"
			button $window.add    -width 13 -text [mc Add] \
				-command "::SubWindow::Category::add $window.list"
			button $window.delete -width 13 -text [mc Delete] \
				-command "::SubWindow::Category::delete $window.list"
			pack $window.list -side left -expand yes -fill both
			pack $window.y -side left -fill y
			pack $window.rename $window.add $window.delete -padx 4 -pady 4
			#Set Values
			setVal $window.list

			grab set $window
			update
			set w [winfo width $window]
			set h [winfo height $window]
			set x [expr ([winfo vrootwidth $window]  - $w)/2]
			set y [expr ([winfo vrootheight $window] - $h)/2]
			wm minsize $window $w $h
			wm geometry $window $w\x$h+$x+$y
			wm transient $window .
			wm deiconify $window
		}
		
		proc setVal {lbox} {
			variable cat
			set cat [list]
			$lbox delete 0 end
			foreach {id name} [::DB::getCategoryList] {
				$lbox insert end $name
				lappend cat $id
			}
		}
		
		proc add {lbox} {
			variable cat
			SubWindow::InputString::show NEW_NAME
			tkwait window $SubWindow::InputString::window
			if {$SubWindow::InputString::setresult != 1} {return}
			::DB::addCategory $SubWindow::InputString::result
			setVal $lbox
		}

		proc rename {lbox} {
			variable window
			variable cat
			set index [$lbox curselection]
			if {$index == {}} return
			SubWindow::InputString::show [$lbox get $index]
			tkwait window $SubWindow::InputString::window
			if {$SubWindow::InputString::setresult != 1} {
				raise $window
				return
			}
			::DB::updateCategoryName [lindex $cat $index] $SubWindow::InputString::result
			setVal $lbox
		}

		proc delete {lbox} {
			variable cat
			set index [$lbox curselection]
			if {$index == {}} return
			set catid [lindex $cat $index]
			set num   [llength [::DB::getItemListFromCategory $catid]]
			if {$num > 0} {
				if {[tk_messageBox -type okcancel \
				-message "[mc {Number of items being Categorized to it. : }] $num \n[mc {Delete Category. OK?}]\n[mc {Items are not deleted.}]"] == {cancel}} {return}
			}
			::DB::deleteCategory $catid
			::DB::deleteCategoryFromItem {} $catid
			setVal $lbox
		}
		
	}
	
	namespace eval Preference {
		variable window .preference
		variable value
		array set value {}
		variable labelname [list]

		variable setresult 0

		proc show {} {
			variable window
			variable value
			variable labelname
			variable setresult

			set setresult 0
			init 

			toplevel $window
			# Buttons
			frame $window.btn -border 10
			button $window.btn.ok     -width 13 -text [mc OK] \
				-command "
				set SubWindow::Preference::setresult 1 
				destroy $window 
				"
			button $window.btn.cancel -width 13 -text [mc Cancel] \
				-command "destroy $window"
			pack $window.btn.ok $window.btn.cancel -side left -anchor c -padx 4
			pack $window.btn -side bottom
			# NoteBook
			NoteBook $window.notebook
			$window.notebook insert end color -text {Color}
			$window.notebook insert end other -text {Other}
			set fcol [$window.notebook getframe color]
			set foth [$window.notebook getframe other]
			$window.notebook raise color
			# Color Setting Frame
			# ----------------------------------------
			# Label
			set FL [labelframe $fcol.label -text [mc Label] -pady 4]
			pack $FL -fill both -expand yes
			for {set i 0} {$i<=9} {incr i} {
				set F [frame $FL.f$i]
				set fg      $value(color_label_fg$i)
				set bg      $value(color_label_bg$i)
				set fg_sel  $value(color_label_fg_sel$i)
				set bg_sel  $value(color_label_bg_sel$i)
				#Normal Color
				label $F.smpns -width 10 -text [lindex $labelname $i] -bg $bg -fg $fg
				button $F.colnsfg -width 5 -bg $fg -activebackground $fg \
					-command "SubWindow::Preference::changeLabelColor $F.smpns $F.colnsfg $i fg"
				button $F.colnsbg -width 5 -bg $bg -activebackground $bg \
					-command "SubWindow::Preference::changeLabelColor $F.smpns $F.colnsbg $i bg"
				#Selected Color
				label $F.smpsl -width 10 -text [lindex $labelname $i] -bg $bg_sel -fg $fg_sel
				button $F.colslfg -width 5 -bg $fg_sel -activebackground $fg_sel \
					-command "SubWindow::Preference::changeLabelColor $F.smpsl $F.colslfg $i fg_sel"
				button $F.colslbg -width 5 -bg $bg_sel -activebackground $fg_sel \
					-command "SubWindow::Preference::changeLabelColor $F.smpsl $F.colslbg $i bg_sel"
				
				pack $F.smpns $F.colnsfg $F.colnsbg -side left -padx 4
				pack $F.smpsl $F.colslfg $F.colslbg -side left -padx 4
				pack $F -pady 1
			}
			# Other
			set F [labelframe $fcol.other -text [mc Other] -pady 4]
			pack $F -fill both -expand yes
			label  $F.coll0 -text ListBase
			button $F.colb0 -width 5 -bg $value(color_list_base) -activebackground $value(color_list_base) \
				-command "SubWindow::Preference::changeColor $F.colb0 color_list_base"
			label  $F.coll1 -text ListBorder
			button $F.colb1 -width 5 -bg $value(color_list_border) -activebackground $value(color_list_border) \
				-command "SubWindow::Preference::changeColor $F.colb1 color_list_border"
			label  $F.coll2 -text ThumbnailBase
			button $F.colb2 -width 5 -bg $value(color_thumb_base) -activebackground $value(color_thumb_base) \
				-command "SubWindow::Preference::changeColor $F.colb2 color_thumb_base"
			label  $F.coll3 -text ThumbnailOutline
			button $F.colb3 -width 5 -bg $value(color_thumb_outline) -activebackground $value(color_thumb_outline) \
				-command "SubWindow::Preference::changeColor $F.colb3 color_thumb_outline"
			label  $F.coll4 -text ThumbnailShadow
			button $F.colb4 -width 5 -bg $value(color_thumb_shadow) -activebackground $value(color_thumb_shadow) \
				-command "SubWindow::Preference::changeColor $F.colb4 color_thumb_shadow"
			grid $F.coll0 -row 0 -column 0 
			grid $F.colb0 -row 0 -column 1 -pady 2
			grid $F.coll1 -row 0 -column 2 
			grid $F.colb1 -row 0 -column 3
			
			grid $F.coll2 -row 1 -column 0
			grid $F.colb2 -row 1 -column 1 -pady 2
			grid $F.coll3 -row 1 -column 2
			grid $F.colb3 -row 1 -column 3
			
			grid $F.coll4 -row 2 -column 0
			grid $F.colb4 -row 2 -column 1 -pady 2

			# Other Setting Frame
			# ----------------------------------------
			set exitcmd {}
			# DB Settiog
			set FL [labelframe $foth.db -text [mc Database] -pady 4 -padx 4]
			pack $FL -fill x -side top
			label $FL.dbrootl -text DBRootPath
			entry  $FL.dbroote
			$FL.dbroote insert end $value(rootdir)
			label $FL.thumsizel -text ThumbnailSize
			entry $FL.thumsizee -validate focus -vcmd {
				if {[catch {expr int(%P)}]} {
					bell
					%W delete 0 end
					%W insert end $SubWindow::Preference::value(thumb_size)
					return 0
				}
				set SubWindow::Preference::value(thumb_size) %P
				return 1
			}
			$FL.thumsizee insert end $value(thumb_size)
			append exitcmd "
			set SubWindow::Preference::value(rootdir) \[$FL.dbroote get\] 
			set SubWindow::Preference::value(thumb_size) \[$FL.thumsizee get\] \n
			"
			grid $FL.dbrootl   -row 0 -column 0
			grid $FL.dbroote   -row 0 -column 1 -sticky ew
			grid $FL.thumsizel -row 1 -column 0
			grid $FL.thumsizee -row 1 -column 1 -sticky w
			grid columnconfigure $FL 1 -weight 1
			# Format Setting
			set FL [labelframe $foth.format -text [mc Format] -pady 4 -padx 4]
			pack $FL -fill x -side top
			label $FL.dateformatl -text DateFormat
			entry  $FL.dateformate
			$FL.dateformate insert end $value(format_date)
			label $FL.infoformatl -text InfomationFormat
			entry  $FL.infoformate
			$FL.infoformate insert end $value(format_info)
			append exitcmd "
			set SubWindow::Preference::value(format_date) \[$FL.dateformate get\] 
			set SubWindow::Preference::value(format_info) \[$FL.infoformate get\] \n
			"
			grid $FL.dateformatl -row 0 -column 0
			grid $FL.dateformate -row 0 -column 1 -sticky ew
			grid $FL.infoformatl -row 1 -column 0
			grid $FL.infoformate -row 1 -column 1 -sticky ew
			grid columnconfigure $FL 1 -weight 1
			# SlideShow Setting
			set FL [labelframe $foth.slideshow -text [mc SlideShow] -pady 4 -padx 4]
			pack $FL -fill x -side top
			label $FL.waitl -text [mc WaitSecTime]
			spinbox $FL.waits -from 0 -to 100 \
				-textvariable ::SubWindow::Preference::value(slideshow_wait)
#            $FL.dateformate insert end $value(format_date)
#            append exitcmd "
#            set SubWindow::Preference::value(format_date) \[$FL.dateformate get\] 
#            "
			grid $FL.waitl -row 0 -column 0
			grid $FL.waits -row 0 -column 1 -sticky e
			grid columnconfigure $FL 1 -weight 1
			
			# Update command 
			set cmd [$window.btn.ok cget -command]
			append exitcmd \n $cmd
			$window.btn.ok configure -command $exitcmd

			pack $window.notebook -fill both -expand yes
			grab set $window
			update
			set w [winfo width $window]
			set h [winfo height $window]
			set x [expr ([winfo vrootwidth $window]  - $w)/2]
			set y [expr ([winfo vrootheight $window] - $h)/2]
			wm minsize $window $w $h
			wm geometry $window $w\x$h+$x+$y
			wm transient $window .
			wm deiconify $window

#            focus $window
		}

		proc init {} {
			variable value
			variable labelname
			
			set labelname [list]
			foreach key [array names value] {
				unset value($key)
			}
			# ThumList Value
			for {set i 0} {$i<=9} {incr i} {
				set lval $::ThumList::label($i)
				lappend labelname [lindex $lval 0]
				set value(color_label_fg$i)     [lindex $lval 1]
				set value(color_label_fg_sel$i) [lindex $lval 2]
				set value(color_label_bg$i)     [lindex $lval 3]
				set value(color_label_bg_sel$i) [lindex $lval 4]
			}
			set value(color_list_border)  $::ThumList::color(list_border)
			set value(color_list_base)    $::ThumList::color(list_base)
			set value(color_thumb_base)    $::ThumList::color(thum_base)
			set value(color_thumb_outline) $::ThumList::color(thum_outline)
			set value(color_thumb_shadow)  $::ThumList::color(thum_shadow)
			# 
			set value(rootdir)     [::DB::getInfo rootdir]
			set value(thumb_size)  $::Image::thum_size
			set value(format_date) $::ThumList::pref(timeformat)
			set value(format_info) $::StatusBar::format
			#
			set value(slideshow_wait) $::SubWindow::SlideShow::wait
		}

		# Set Label Color num=[Label Number] type=fg,bg,fg_sel,bg_sel
		proc changeLabelColor {label btn num type} {
			variable window
			variable value

			set ncol [tk_chooseColor -initialcolor [$btn cget -bg]]
			if {$ncol=={}} {
				raise $window
				return
			}
			
#            tk_messageBox -message $ncol
			$btn configure -bg $ncol -activebackground $ncol
			switch -- $type {
				fg {
					set value(color_label_fg$num) $ncol
					$label configure -fg $ncol
				}
				bg {
					set value(color_label_bg$num) $ncol
					$label configure -bg $ncol
				}
				fg_sel {
					set value(color_label_fg_sel$num) $ncol
					$label configure -fg $ncol
				}
				bg_sel {
					set value(color_label_bg_sel$num) $ncol
					$label configure -bg $ncol
				}
			}
			raise $window
		}

		# Set Other Color
		proc changeColor {btn valkey} {
			variable window
			variable value

			set ncol [tk_chooseColor -initialcolor [$btn cget -bg]]
			if {$ncol=={}} {
				raise $window
				return
			}
			
			$btn configure -bg $ncol -activebackground $ncol
			set value($valkey) $ncol
			raise $window
		}

	}

	namespace eval SlideShow {
		variable window .slideshow
		variable wait   3;# Second
		variable pause  0;# Flag for pause
		variable next   0;# Flag for next page

		proc run {filelist} {
			variable window
			variable wait
			variable next

			toplevel $window
			canvas $window.cnv
			$window.cnv configure -bg #000000 -highlightthickness 0 \
				-xscrollincrement 1 \
				-yscrollincrement 1
			pack $window.cnv -expand yes -fill both

			grab set $window
			wm overrideredirect $window 1
			::Util::setTopmost $window 1
			set w [winfo vrootwidth $window]
			set h [winfo vrootheight $window]
			wm minsize $window $w $h
			wm geometry $window $w\x$h+0+0
			$window.cnv create rectangle [expr -$w/2] [expr -$h/2] [expr $w/2] [expr $h/2] -width 0
			$window.cnv create image 0 0 -anchor c -tag img
			wm transient $window .
			wm deiconify $window
			focus -force $window
			# Stop Slide show
			bind $window <KeyPress-Escape> "destroy $window"
			bind $window <KeyPress-q>      "destroy $window"
			# Speed Down Slide show
			bind $window <KeyPress-Left>   {
				incr ::SubWindow::SlideShow::wait
			}
			# Speed Up Slide show
			bind $window <KeyPress-Right>  {
				incr ::SubWindow::SlideShow::wait -1
				if {$::SubWindow::SlideShow::wait < 0} {
					set ::SubWindow::SlideShow::wait 0
				}
			}
			# Pause / Start Slide show
			bind $window <KeyPress-space>  {
				if {$::SubWindow::SlideShow::pause == 0} {
					set ::SubWindow::SlideShow::pause 1
					vwait ::SubWindow::SlideShow::pause
				} else {
					set ::SubWindow::SlideShow::pause 0
				}
			}
			# Go Next soon.
			bind $window <KeyPress-Return> {
				after cancel set SubWindow::SlideShow::next 1
				set SubWindow::SlideShow::next 1
			}
			while {1} {
				if {![winfo exists $window]} {break}
				set file [lindex $filelist 0]
				set img [::Image::getPrevImg [::Util::getRelative [pwd] $file] $w $h -1]
				if {![winfo exists $window]} {break}
				$window.cnv itemconfigure img -image $img
				if {![winfo exists $window]} {break}
				$window.cnv configure -scrollregion [$window.cnv bbox all]
				update
				lappend filelist $file
				set filelist [lreplace $filelist 0 0]
				# Sleep
				set next 0
				after [expr $wait * 1000] set SubWindow::SlideShow::next 1
				vwait SubWindow::SlideShow::next
			}
		}

	}

	namespace eval InputString {
		variable window .inputstring
		variable result {}
		variable setresult 0

		proc show {str} {
			variable window
			variable result {}
			variable setresult 0

			toplevel $window
			# Buttons
			frame $window.btn -border 10
			button $window.btn.ok     -width 13 -text [mc OK] \
				-command "
				set SubWindow::InputString::result \[$window.entry get\]
				set SubWindow::InputString::setresult 1
				destroy $window "
			button $window.btn.cancel -width 13 -text [mc Cancel] \
				-command "destroy $window"
			pack $window.btn.ok $window.btn.cancel -side left -anchor c -padx 4
			pack $window.btn -side bottom
			# Entry
			entry $window.entry -takefocus on
			$window.entry insert 0 $str
			pack $window.entry -fill x -padx 4 -pady 4
			$window.entry selection range 0 end 

			grab set $window
			update
			set w [winfo width $window]
			set h [winfo height $window]
			set x [expr ([winfo vrootwidth $window]  - $w)/2]
			set y [expr ([winfo vrootheight $window] - $h)/2]
			wm minsize $window $w $h
			wm geometry $window $w\x$h+$x+$y
			wm transient $window .
			wm deiconify $window

			focus $window.entry
		}
	}
	
	namespace eval ProgressDlg {
		variable window .progressdlg
		variable val 0
		variable max 0
		variable msg {} 

		proc show {maximum} {
			variable window
			variable max 
			variable msg 

			if {$maximum==0} {return}
			set msg {}
			set max $maximum
			toplevel $window
			# Buttons
			frame $window.btn -border 10
			button $window.btn.cancel -width 13 -text [mc Cancel] \
				-command "destroy $window"
			pack  $window.btn.cancel -side left -anchor c -padx 4
			pack $window.btn -side bottom

			# Label
			label $window.label -textvariable ::SubWindow::ProgressDlg::msg \
				-justify left -anchor nw -height 3 -wraplength 360
			# ProgressBar
			ProgressBar $window.pb -width 360 -relief sunken \
				-maximum $max -variable ::SubWindow::ProgressDlg::val
			pack $window.label -side top -fill x -expand yes -padx 4 -pady 4
			pack $window.pb -side top -fill x -expand yes -padx 4 -pady 10

			grab set $window
			update
			set w [winfo width $window]
			set h [winfo height $window]
			set x [expr ([winfo vrootwidth $window]  - $w)/2]
			set y [expr ([winfo vrootheight $window] - $h)/2]
			wm minsize $window $w $h
			wm geometry $window $w\x$h+$x+$y
			wm transient $window .
			wm deiconify $window
			focus $window
		}

		proc setMsg {text} {
			variable msg
			set msg $text
		}

		proc increment {num} {
			variable val
			variable max
			variable window

			incr val $num
			if {$val >= $max} {
				destroy $window
			}
		}
	}
}

namespace eval Util {
	# Command for Random sort(lsort only.TreeCtrl's item sort will be error)
	proc compareRand {len a b} {
		return [expr round($len*(rand()-rand()))]
	}

	# Sleep
	proc sleep {time} {
		after $time set end 1
		vwait end
	}
	
	# Change window attribute to always on top.(topmost)
	proc setTopmost {w bool} {
		if { $::tcl_platform(platform)=={windows} } {
			raise $w
			wm attributes $w -topmost $bool
		} else {
			set taglist [bindtags $w]
			set index [lsearch $taglist topmost$w]
			if { $bool } {
				if {$index == -1} {
				bindtags $w [linsert $taglist 0 topmost$w]
				bind topmost$w <Visibility> "raise $w" 
				}
			} else {
				if {$index != -1} {
				bindtags $w [lreplace $taglist $index $index]
				bind $w <Visibility> {}
				}
			}
		}
	}
	
	# Get Filelist form Directory
	proc getFiles {dirlist} {
		array set files {}
		while {[llength $dirlist]>0} {
			if {[catch {glob -directory [file normalize [lindex $dirlist 0]] -- *} flist]} {
				set flist {}
			}
			foreach file $flist {
				if {[file isfile $file]} {
					set files($file) {}
				} else {
					lappend dirlist $file
				}
			}
			set dirlist [lreplace $dirlist 0 0]
		}
		return [lsort [array names files]]
	}
	
	# Get Relative Path Name
	proc getRelative {base path} {
		set base [file split [file normalize $base]]
		set path [file split [file normalize $path]]
		set baselen [llength $base]
		set relative [list]
		for {set i 0} {$i<$baselen} {incr i} {
			if {[lindex $base $i] != [lindex $path $i]} {
				for {set u $i} {$u<$baselen} {incr u} {
					lappend relative ..
				}
				break;
			}
		}
		return [join [concat $relative [lrange $path $i end]] /]
	}
		
	# Check parent - child relation
	proc isChild {parent child} {
		if {[file exists $parent]==0} {return 0}
		if {[file exists $child]==0} {return 0}
		if {[file isfile $parent]} {return 0}
		set plist [file split [file normalize $parent]]
		set clist [file split [file normalize $child]]
		set len [llength $plist]
		for {set i 0} {$i<$len} {incr i} {
			if {[lindex $plist $i] eq [lindex $clist $i]} {
				continue
			} else {
				return 0
			}
		}
		return 1
	}

}

namespace eval Cmd {
	# User Command
	# ===============================================
	# check db is opening
	proc checkOpen {} {
		if {$::DB::dbfile == {} } {return 0}
		return 1
	}
	
	# Open DB
	proc open {file menu} {
		if {[checkOpen] == 1} {
			tk_messageBox -message [mc {You need to open DB.}]
			return 1
		}
		if {$file=={}} {
			set file [tk_getOpenFile]
			if {$file=={}} {return}
		}

		if {[::DB::open $file] != 0} {return 1}
		_init $file $menu
	}

	# Create New DB
	proc new {file menu} {
		if {[checkOpen] == 1} {
			tk_messageBox -message [mc {You need to open DB.}]
			return 1
		}
		if {$file=={}} {
			set file [tk_getSaveFile]
		}
		if {$file=={}} {return 1}
		if {[::DB::new $file] != 0} {return 1}
		_init $file $menu
	}

	# Close DB
	proc close {} {
		if {[checkOpen] == 0} {return}
		_clean
		DB::close
		ThumList::clear
		Image::vacuum
	}
	
	# Init and prepare to use widgets.
	proc _init {file menu} {
		ThumList::setLabelName    [DB::getLabelList]
		ThumList::setCategoryName [DB::getCategoryList]
		set geo [DB::getInfo window_geometry]
		if {$geo != {}} {wm geometry . $geo}
		wm title . "$::pref(appname) : $::DB::dbfile"
		if {[::DB::getInfo color_label_fg0] != {}} {
			for {set i 0} {$i<=9} {incr i} {
				set llist [list]
				lappend llist [lindex $::ThumList::label($i) 0]
				lappend llist [::DB::getInfo color_label_fg$i]    
				lappend llist [::DB::getInfo color_label_fg_sel$i]
				lappend llist [::DB::getInfo color_label_bg$i]    
				lappend llist [::DB::getInfo color_label_bg_sel$i]
				set ThumList::label($i) $llist
			}
			set ::ThumList::color(list_border)  [::DB::getInfo color_list_border]   
			set ::ThumList::color(list_base)    [::DB::getInfo color_list_base]
			set ::ThumList::color(thum_base)    [::DB::getInfo color_thumb_base]
			set ::ThumList::color(thum_outline) [::DB::getInfo color_thumb_outline]
			set ::ThumList::color(thum_shadow)  [::DB::getInfo color_thumb_shadow]

			set ::Image::thum_size           [::DB::getInfo thumb_size]  
			set ::ThumList::pref(timeformat) [::DB::getInfo format_date] 
			set ::StatusBar::format          [::DB::getInfo format_info] 

			set ::SubWindow::SlideShow::wait [::DB::getInfo slideshow_wait]
		}
		ThumList::updateStyle
		saveHistory $file
		createFileMenu $menu
	}

	# Clean widgets info
	proc _clean {} {
		DB::setInfo window_geometry [winfo geometry .]
		wm title . $::pref(appname)
	}

	# Exit Application
	proc exit {} {
		if {[checkOpen] != 0} {::Cmd::close}
		::exit 0
	}
	
	# Save Opened File History and Rebuild Menu
	proc saveHistory {file} {
		set hlist [loadHistory]
		set index [lsearch $hlist $file]
		if {$index == -1} {
			set hlist [linsert $hlist 0 $file]
		} else {
			set hlist [linsert [lreplace $hlist $index $index] 0 $file]
		}
		set fp [::open $::pref(history) w]
		foreach file $hlist {
			puts $fp $file
		}
		::close $fp
	}

	# Load Opened File History and Rebuild Menu
	proc loadHistory {} {
		set hlist [list]
		if {![file exists $::pref(history)]} return
		set fp [::open $::pref(history) r]
		while {![eof $fp]} {
			set file [gets $fp]
			if {[file exists $file]} {
				lappend hlist $file
			}
		}
		::close $fp
		return $hlist
	}

	# Add FileInfo to DB
	proc addFile {filelist} {
		if {[checkOpen] == 0} {
			tk_messageBox -message [mc {You need to open DB.}]
			return 1
		}
		if {$filelist=={}} {
			set filelist \
			[tk_getOpenFile -initialdir \{$::DB::rootdir\} -multiple yes]
		}
		::SubWindow::ProgressDlg::show [llength $filelist]
		foreach file $filelist {
			::SubWindow::ProgressDlg::setMsg $file
			update
			set item [::DB::addItem $file]
			if {$item == {} } {
				::SubWindow::ProgressDlg::increment 1
				continue
			}
			::ThumList::addItem $item
			::SubWindow::ProgressDlg::increment 1
			if {![winfo exists $::SubWindow::ProgressDlg::window]} { break }
		}
	}

	# Add FileInfo of Files in Directory to DB
	proc addDir {dirlist} {
		if {[checkOpen] == 0} {
			tk_messageBox -message [mc {You need to open DB.}]
			return 1
		}
		if {$dirlist=={}} {
			set dir \
			[tk_chooseDirectory -initialdir \{$::DB::rootdir\} -mustexist yes]
			if {$dir=={}} {return}
		}
        set filelist [::Util::getFiles [list $dir]]
		addFile $filelist
	}

	# Search and set result to ThumList
	proc search {} {
		SearchBox::addHistory $::SearchBox::statement
		ThumList::clear
		::Image::vacuum
		foreach item [::DB::search $::SearchBox::statement] {
			::ThumList::addItem $item
		}
	}

	# Show Database Infomation
	proc showDBInfo {} {
		set str {}
		set idlist [DB::getAllID]
		set desclist [ThumList::getAll]
		append str "[format %\ 10d [llength $idlist]] : Item Number \n"
		append str "[format %\ 10d [llength $desclist]] : Shown Item Number \n"
		tk_messageBox -message $str
	}

	# Find (Search) by key
	proc findBy {key val} {
		ThumList::clear
		::Image::vacuum
		switch -- $key {
			category {
				foreach id [::DB::getItemListFromCategory $val] {
					::ThumList::addItem [::DB::getItem $id]
				}
			}
			default {
				foreach item [::DB::search $key=$val] {
					::ThumList::addItem $item
				}
			}
		}
	}

	# Show and Set Preference
	proc setPreference {} {
		# Show Window
		::SubWindow::Preference::show
		tkwait window $::SubWindow::Preference::window
		if {$::SubWindow::Preference::setresult != 1} {
			return
		}
		# Update DB
		::DB::command {begin}
		foreach {key val} [array get ::SubWindow::Preference::value] {
			if {$key == {thumb_size}} {
				if {[catch {expr int($val)}]} {
					set $val Image::thum_size
				}
			}
			::DB::setInfo $key $val
		}
		::DB::command {commit}
		# Update GUI
		set ::ThumList::color(list_borer)   $::SubWindow::Preference::value(color_list_border)
		set ::ThumList::color(list_base)    $::SubWindow::Preference::value(color_list_base)
		set ::ThumList::color(thum_base)    $::SubWindow::Preference::value(color_thumb_base)
		set ::ThumList::color(thum_outline) $::SubWindow::Preference::value(color_thumb_outline)
		set ::ThumList::color(thum_shadow)  $::SubWindow::Preference::value(color_thumb_shadow)
		for {set i 0} {$i<=9} {incr i} {
			set llist $::ThumList::label($i)
			set llist [lreplace $llist 1 1 $::SubWindow::Preference::value(color_label_fg$i)]
			set llist [lreplace $llist 2 2 $::SubWindow::Preference::value(color_label_fg_sel$i)]
			set llist [lreplace $llist 3 3 $::SubWindow::Preference::value(color_label_bg$i)]
			set llist [lreplace $llist 4 4 $::SubWindow::Preference::value(color_label_bg_sel$i)]
			set ::ThumList::label($i) $llist
		}
		set Image::thum_size           $::SubWindow::Preference::value(thumb_size)  
		set ThumList::pref(timeformat) $::SubWindow::Preference::value(format_date) 
		set StatusBar::format          $::SubWindow::Preference::value(format_info)
		::ThumList::updateStyle
		#
		set ::SubWindow::SlideShow::wait $::SubWindow::Preference::value(slideshow_wait)
	}

	# Item Command 
	# ===============================================

	# change Label
	proc changeLabel {desclist labelnum} {
		if {[llength desclist]==0} {return}
		foreach desc $desclist {
			::DB::updateItem [list [ThumList::getID $desc]] [list label $labelnum]

			::ThumList::changeStyle $desc $labelnum
			set StatusBar::text \
			[ThumList::getInfoString $desc $StatusBar::format]
		}
	}

	# change Importance
	proc changeImportance {desclist impnum} {
		if {[llength desclist]==0} {return}
		set idlist [list]
		foreach desc $desclist {lappend idlist [ThumList::getID $desc]}
		
		::DB::updateItem $idlist [list importance $impnum]
		::ThumList::updateItem $desclist [list importance $impnum]
		set StatusBar::text \
		[ThumList::getInfoString [lindex $desclist end] $StatusBar::format]
	}
	
	# change Category
	proc changeCategory {desclist catnum on} {
		if {[llength desclist]==0} {return}
		set idlist [list]
		foreach desc $desclist {lappend idlist [ThumList::getID $desc]}
		
		# Set DB
		if {$on==1} {
			::DB::addItemToCategory $idlist [list $catnum]
		} else {
			::DB::deleteItemFromCategory $idlist [list $catnum]
		}
		# Set ThumList
		if {$on==1} {
			foreach desc $desclist {
				set catlist [lsort -unique -integer \
					[concat $catnum [::ThumList::getData $desc category]]]
				::ThumList::setData $desc [list category $catlist]
			}
		} else {
			foreach desc $desclist {
				set olist [::ThumList::getData $desc category]
				set delindex [lsearch $olist $catnum]
				set catlist [lreplace $olist $delindex $delindex]
				::ThumList::setData $desc [list category $catlist]
			}
		}
	}

	# Event for Selection Change
	proc changeSelectionInfo {} {
		set desclist [::ThumList::getSelected]
		foreach key [array names ::sel_category] {
			unset ::sel_category($key)
		}
		set ::sel_importance {}
		set ::sel_label      {}
		if {[llength $desclist]==0} {return}

		set imp     [ThumList::getData [lindex $desclist 0] importance]
		set label   [ThumList::getData [lindex $desclist 0] label]
		set catlist [ThumList::getData [lindex $desclist 0] category]
		foreach desc $desclist {
			if {[ThumList::getData $desc importance] != $imp || $imp == {}} {
				set imp {}
			}
			if {[ThumList::getData $desc label] != $label || $label == {}} {
				set label {}
			}
			if {[llength $catlist] > 0} {
				set mcatlist [ThumList::getData $desc category]
				foreach id $catlist {
					if {[lsearch $mcatlist $id] == -1} {
						set delindex [lsearch $catlist $id]
						set catlist [lreplace $catlist $delindex $delindex]
					}
				}
			}
		}
		set ::sel_importance $imp
		set ::sel_label      $label
		foreach cat $catlist {
			set ::sel_category($cat) 1
		}
	}

	# show SetComment Window
	proc setComment {} {
		set desclist [::ThumList::getSelected]
		if {[llength $desclist]==0} {return}
		# get Comments. if all items comment are same, show it, 
		# but if not same , show blank.
		set showcomment [ThumList::getData [lindex $desclist 0] comment]
		foreach desc $desclist {
			if {[ThumList::getData $desc comment] ne $showcomment} {
				set showcomment {}
				break
			}
		}
		# Show Window
		::SubWindow::Comment::show $showcomment
		tkwait window $::SubWindow::Comment::window
		if {$::SubWindow::Comment::setresult != 1} {
			return
		}
		set result $::SubWindow::Comment::result

		# Set Comments
		foreach desc $desclist {
			ThumList::setData $desc [list comment $result]
			DB::updateItem [ThumList::getID $desc] [list comment $result]
		}
	}
	
	# Edit Label Name
	proc editLabel {menu} {
		::DB::command {begin}
		# Show Window
		::SubWindow::Label::show
		tkwait window $::SubWindow::Label::window
		if {$::SubWindow::Label::result != 1} {
			::DB::command {rollback}
			return
		}
		::DB::command {commit}
		
		# Update ThumList
		::ThumList::setLabelName [::DB::getLabelList]
		::Cmd::createLabelMenu [join [list $menu _select] {}] select
		::Cmd::createLabelMenu [join [list $menu _set] {}] set
		::Cmd::createLabelMenu [join [list $menu _find] {}] find
		#Update Item
		foreach desc [::ThumList::getAll] {
			::ThumList::setData $desc [list label [::ThumList::getData $desc label]]
		}
	}

	# Edit Category Name / Add /Remove
	proc editCategory {menu} {
		::DB::command {begin}
		# Show Window
		::SubWindow::Category::show
		tkwait window $::SubWindow::Category::window
		if {$::SubWindow::Category::result != 1} {
			::DB::command {rollback}
			return
		}
		::DB::command {commit}
		# Update ThumList
		::ThumList::clearCategory
		::ThumList::setCategoryName [::DB::getCategoryList]
		# Update Menu
		::Cmd::createCategoryMenu [join [list $menu _select] {}] select
		::Cmd::createCategoryMenu [join [list $menu _set   ] {}] set
		::Cmd::createCategoryMenu [join [list $menu _find  ] {}] find
		
		#Update Item
		foreach desc [ThumList::getAll] {
			set clist [::DB::getCategoryListFromItem [::ThumList::getID $desc]]
			ThumList::setData $desc [list category $clist]
		}
	}
	
	# Rebuild Thumbnail Selected
	proc rebuildThumSel {} {
		DB::command begin
		foreach desc [::ThumList::getSelected] {
			set id [::ThumList::getID $desc]
			set olist [::DB::updateThumbnail $id]
			::ThumList::setData $desc $olist
		}
		DB::command commit
		Image::vacuum
		tk_messageBox -message [mc OK]
	}

	# Rebuild Thumbnail All
	proc rebuildThumAll {} {
		DB::command begin
		foreach id [::DB::getAllID] {
			::DB::updateThumbnail $id
		}
		DB::command commit
		# Update ThumList
		set idlist [::ThumList::getAllID]
		::ThumList::clear
		Image::vacuum
		foreach id $idlist {
			::ThumList::addItem [::DB::getItem $id]
		}
		Image::vacuum
		tk_messageBox -message [mc OK]
	}

	# Select & Copy/Paste Edit
	# ===============================================
	
	# Select All
	proc selectAll {} {
		::ThumList::setSelectionAll
	}
	
	# Select
	proc selectBy {key val} {
		set desclist [::ThumList::getAll]
		set sellist [list]
		switch -- $key {
			category {
				foreach desc $desclist {
					if {[lsearch [ThumList::getData $desc category] $val] != -1} {
						lappend sellist $desc
					}
				}
			}

			default {
				foreach desc $desclist {
					if {$val==[ThumList::getData $desc $key]} {
						lappend sellist $desc
					}
				}
			}
		}
		::ThumList::setSelection $sellist
	}
	
	# Invert Selection
	proc invertSelection {} {
		ThumList::invertSelection
	}
	 
	# Cut Item
	proc cut {} {
		copy
		delete
	}
	
	# Copy Item
	proc copy {} {
		set desclist [ThumList::getSelected]
		if {[llength $desclist]==0} {return}
		clipboard clear
		set clist [list]
		foreach desc $desclist {
			set itemid [::ThumList::getID $desc]
			array set item [::DB::getItem $itemid]
            set item(filepath) [file normalize $item(filepath)]
			set item(tkimage) [::DB::getThumb $itemid]
			set catnames [list]
			foreach catid $item(category) {
				lappend catnames [::DB::getCategoryName $catid]
			}
			set item(category) $catnames
			lappend clist [array get item]
		}
		clipboard append $clist
	}
	
	# Paste Item. If there is same file, does not paste.
	proc paste {} {
		foreach vals [clipboard get] {
			array set item $vals
			# if there isn't category make it
			array set cat {}
			foreach {id name} [::DB::getCategoryList] {
				set cat($name) $id
			}
			set catlist [list]
			foreach name $item(category) {
				if {[array names cat $name]=={}} {
					set cat($name) [DB::addCategory $name]
				}
				lappend catlist $cat($name)
			}
			ThumList::setCategoryName [::DB::getCategoryList]
			# add new and update
			array set nitem [DB::addItem $item(filepath)]
			if {$nitem(exists)==0} {
				::DB::updateItem [list $nitem(id)] [list \
					haveThumb	1 \
					thumb		$item(thumb)]
			}
			::DB::updateItem [list $nitem(id)] [list \
				importance	$item(importance) \
				label		$item(label) \
				category	$catlist \
				comment		$item(comment)]
			::ThumList::addItem [::DB::getItem $nitem(id)]
		}
	}
	
	# delete from DB and ThumList.Original file will not delete.
	proc delete {} {
		set desclist [::ThumList::getSelected]
		# Warn
		if {$::pref(warn)==1} {
			set enable [tk_messageBox -type okcancel \
				-message [mc {Delete selected items. OK? Original files are not deleted.}]]
			if {$enable=={cancel}} {return}
		}
		# Delete 
		set i 0
		foreach desc $desclist {
			set itemid [::ThumList::getData $desc id]
			::DB::deleteItem [list $itemid]
			::ThumList::deleteItem [list $desc]
			incr i
		}
		set StatusBar::text \
		[ThumList::getInfoString [lindex [ThumList::getSelected] end] $StatusBar::format]
	}
	
	# delete item from ThumbList. item does not delete from DB.
	proc hide {} {
		::ThumList::deleteItem [::ThumList::getSelected]
	}

	# File Command 
	# ===============================================
	
	# run SlideShow
	proc runSlideShow {} {
		set filelist [list]
		foreach desc [::ThumList::getSelected] {
			lappend filelist [file normalize [ThumList::getData $desc filepath]]
		}
		SubWindow::SlideShow::run $filelist
		raise .
		focus -force .
	}

	# Open with other application
	proc openWith {app} {
		set desclist [::ThumList::getSelected]
		set filelist [list]
		foreach desc $desclist {
			lappend filelist  [file normalize [ThumList::getData $desc filepath]]
		}
		# If need , Quote
		if {[lsearch [string tolower $::pref(quoteapp)] [string tolower [file tail $app]]]!=-1} {
			set newlist [list]
			foreach file $filelist {
				lappend newlist \"$file\"
			}
			set filelist $newlist
		}
		# Run App
#        eval "exec \{[file normalize $app]\} [join $filelist { }] &"
		eval "exec \{$app\} [join $filelist { }] &"

	}

	# Delete Files
	proc deleteFile {} {
		set desclist [::ThumList::getSelected]
		set filelist [list]
		foreach desc $desclist {
			lappend filelist [file normalize [ThumList::getData $desc filepath]]
		}
		# Warn
		if {$::pref(warn)==1} {
			set enable [tk_messageBox -type okcancel \
				-message [mc {Delete files. OK?}]\n\n[join $filelist \n]]
			if {$enable=={cancel}} {return}
		}
		# Delete 
		set i 0
		foreach desc $desclist {
			if {[catch {file delete -force -- [lindex $filelist $i]} msg]} {
				tk_messageBox -message $msg
				return
			}
			set itemid [::ThumList::getData $desc id]
			::DB::deleteItem [list $itemid]
			::ThumList::deleteItem [list $desc]
			incr i
		}
		set StatusBar::text \
		[ThumList::getInfoString [lindex [ThumList::getSelected] end] $StatusBar::format]
	}

	# Move Files
	proc moveFile {} {
		set desclist [::ThumList::getSelected]
		set filelist [list]
		foreach desc $desclist {
			lappend filelist [file normalize [ThumList::getData $desc filepath]]
		}
		set dir [_chooseDir]
		if {$dir=={}} {return}

		set i 0
		foreach desc $desclist {
			set srcfile [lindex $filelist $i]
			# Check same name
			if {[file exists [file join $dir [file tail $srcfile]]]} {
				set overwrite [tk_messageBox -type okcancel \
					-message [mc {There is same name file. can I overwrite it?}]]
				if {$overwrite=={cancel}} {continue}
			}
			# Move file
			if {[catch {file rename -force -- $srcfile $dir} msg]} {
				tk_messageBox -message $msg
				return
			}
			# Update DB and TreeCtrl
			set opt [list filepath [file join $dir [file tail $srcfile]]]
			set itemid [::ThumList::getData $desc id]
			::DB::updateItem [list $itemid] $opt
			::ThumList::updateItem [list $desc] \
				[::DB::getData [list $itemid] [list filepath]]
			incr i
		}
		set StatusBar::text \
		[ThumList::getInfoString [lindex [ThumList::getSelected] end] $StatusBar::format]
	}

	# Copy Files
	proc copyFile {} {
		set desclist [::ThumList::getSelected]
		set filelist [list]
		foreach desc $desclist {
			lappend filelist [file normalize [ThumList::getData $desc filepath]]
		}
		set dir [_chooseDir]
		if {$dir=={}} {return}

		foreach srcfile $filelist {
			# Check same name
			if {[file exists [file join $dir [file tail $srcfile]]]} {
				set overwrite [tk_messageBox -type okcancel \
					-message [mc {There is same name file. can I overwrite it?}]]
				if {$overwrite=={cancel}} {continue}
			}
			# Copy
			file copy -force -- $srcfile $dir
		}
	}
	
	# Rename Tool
	proc renameFile {} {
		set desclist [::ThumList::getSelected]
		set filelist [list]
		foreach desc $desclist {
			lappend filelist [ThumList::getData $desc filepath]
		}
		::SubWindow::Rename::show $filelist
		tkwait window $::SubWindow::Rename::window

		set i 0
		foreach {before after} $::SubWindow::Rename::result {
			if {[catch {file rename -- $before $after} msg]} {
				tk_messageBox -message $msg
				continue
			}
			set desc     [lindex $desclist $i]
			set itemid   [::ThumList::getID $desc]
			set filepath [::Util::getRelative [pwd] $after]
			set filename [file tail $after]
			DB::updateItem [list $itemid] [list filepath $filepath filename $filename]
			ThumList::updateItem [list $desc] [list filepath $filepath filename $filename]
			incr i
		}
	}

	# Select or if no exists make directry. Return directory name.
	proc _chooseDir {} {
		set dir [tk_chooseDirectory -title [mc {Choose the destination directory.}] ]
		if {$dir=={}} {return}
		if {[file exists $dir] && [file isfile $dir]} {
			tk_messageBox -message [mc {Same name file is exists. cannot make dir.}]\n$dir
			return {}
		}
		if {![file exists $dir]} {
			if {[catch {file mkdir $dir} msg]} {
				tk_messageBox -message $msg
				return {}
			}
		}
		return $dir
	}

	# Window Command 
	# ===============================================
	# Set Preview Canvas Image
	proc setPreview {} {
		set desclist [::ThumList::getSelected]
		if {$desclist=={}} {
			::Prev::clear
			return
		}
		set ::Prev::pref(id) [::ThumList::getID [lindex $desclist 0]]
		::Prev::setImage
	}

	# change View Thumbnail <-> ListTable <-> Preview
	proc changeView {thumframe prevframe view} {
		if {$view=={prev}} {
			if {[catch {pack info $prevframe}]} {
				pack forget $thumframe
				pack $prevframe -expand yes -fill both
			}
		} else {
			if {[catch {pack info $thumframe}]} {
				pack forget $prevframe
				pack $thumframe -expand yes -fill both
			}
			ThumList::switchView $view
		}
	}

	# Create File Menu
	proc createFileMenu {menu} {
		$menu delete 0 end
		$menu add command -label [mc Open...] -command "::Cmd::open {} $menu"
		$menu add command -label [mc New...]  -command "::Cmd::new {} $menu"
		$menu add command -label [mc Close]   -command {::Cmd::close}
		$menu add separator
		$menu add command -label [mc AddFile...]    -command {::Cmd::addFile {}}
		$menu add command -label [mc AddFromDir...] -command {::Cmd::addDir {}}
		$menu add separator
		$menu add command -label [mc Exit]    -command "::Cmd::exit"
		$menu add separator
		foreach file [loadHistory] {
		$menu add command -label $file -command "Cmd::close; Cmd::open \{$file\} $menu"
		}
	}

	# CreateOptionMenu
	proc create_optionmenu {button menu} {
		$button configure \
		-command " set x \[winfo rootx $button\]
			set y \[winfo rooty $button\]
			set h \[winfo height $button\]
			tk_popup $menu \[expr \$x\] \[expr \$y + \$h\]
		"
	}

	# Create Open with Menu
	proc createOpenWithMenu {menu} {
		$menu delete 0 end
		foreach app $::pref(app) {
		$menu add command -label $app -command "Cmd::openWith \{$app\}"
		}
	}

	# Create Importance Menu
	proc createImportanceMenu {menu type} {
		$menu delete 0 end
		for {set i 0} {$i<=9} {incr i} {
			set labelstr "[mc Importance] $i"
			switch -- $type {
				select {
					set cmd "Cmd::selectBy importance $i"
					$menu add command -label $labelstr -command $cmd
				}
				set {
					set cmd "::Cmd::changeImportance \[::ThumList::getSelected\] $i"
					$menu add radiobutton -label $labelstr -command $cmd \
					-variable ::sel_importance -value $i
				}
				find {
					set cmd "Cmd::findBy importance $i"
					$menu add command -label $labelstr -command $cmd
				}
			}
		}
	}

	# Create Label Menu
	proc createLabelMenu {menu type} {
		$menu delete 0 end
		for {set i 0} {$i<=9} {incr i} {
			set labelstr [ThumList::getLabelName $i]
			switch -- $type {
				select {
					$menu add command -label $labelstr \
					-command "Cmd::selectBy label $i"
				}
				set {
					$menu add radiobutton -label $labelstr \
					-variable ::sel_label -value $i \
					-command "::Cmd::changeLabel \[::ThumList::getSelected\] $i"
				}
				find {
					$menu add command -label $labelstr \
					-command "Cmd::findBy label $i"
				}
			}
		}
		set basename [regsub _.* $menu {}]
		$menu add separator
		$menu add command -label [mc EditLabel...] -command "::Cmd::editLabel $basename"
	}

	# Create Category Menu
	proc createCategoryMenu {menu type} {
		$menu delete 0 end
		foreach {id name} [::ThumList::getCategoryList] {
			switch -- $type {
				select {
					$menu add command -label $name \
					-command "Cmd::selectBy category $id"
				}
				set {
					$menu add checkbutton -label $name \
					-variable ::sel_category($id) \
					-command "Cmd::changeCategory \[::ThumList::getSelected\] $id \$::sel_category($id)"
				}
				find {
					$menu add command -label $name \
					-command "Cmd::findBy category $id"
				}
			}
		}
		set basename [regsub _.* $menu {}]
		$menu add separator
		$menu add command -label [mc EditCategory...] -command "::Cmd::editCategory $basename"
	}

}

# Create Main Window
proc createMainWindow {} {
	# Menu
	# ===============================================
	menu .menu -type menubar
	# Menu (Root)
	. configure -menu .menu
	.menu add cascade -label [mc File]     -menu .menu.file
	.menu add cascade -label [mc Edit]     -menu .menu.edit
	.menu add cascade -label [mc Item]     -menu .menu.item
	.menu add cascade -label [mc Database] -menu .menu.db
	.menu add cascade -label [mc Action]   -menu .menu.action
	# Menu (File)
	set M [menu .menu.file -tearoff no]
	Cmd::createFileMenu $M

	# Menu (Edit)
	menu .menu.edit -tearoff no
	.menu.edit add command -label [mc Cut]       -command {::Cmd::cut}
	.menu.edit add command -label [mc Copy]      -command {::Cmd::copy}
	.menu.edit add command -label [mc Paste]     -command {::Cmd::paste}
	.menu.edit add command -label [mc Delete]    -command {::Cmd::delete}
	.menu.edit add separator
	.menu.edit add command -label [mc Hide]      -command {::Cmd::hide}
	.menu.edit add separator
	.menu.edit add command -label [mc InvertSelection] -command {::Cmd::invertSelection}
	.menu.edit add command -label [mc SelectAll] -command {::Cmd::selectAll}
	.menu.edit add cascade -label [mc SelectByImportance] -menu .menu.importance_select
	.menu.edit add cascade -label [mc SelectByLabel]      -menu .menu.label_select
	.menu.edit add cascade -label [mc SelectByCategory]   -menu .menu.category_select
	.menu.edit add separator
	.menu.edit add command -label [mc Preference...] -command {::Cmd::setPreference}
	# SubMenu (Select Importance)
	menu .menu.importance_select -tearoff on \
	-postcommand {::Cmd::createImportanceMenu .menu.importance_select select}
	# SubMenu (Select Label)
	menu .menu.label_select -tearoff on \
	-postcommand {::Cmd::createLabelMenu .menu.label_select select}
	# SubMenu (Select Category)
	menu .menu.category_select -tearoff on \
	-postcommand {::Cmd::createCategoryMenu .menu.category_select select}
	
	# Menu (Item)
	menu .menu.item -tearoff no
	.menu.item add cascade -label [mc SetImportance] -menu .menu.importance_set
	.menu.item add cascade -label [mc SetLabel]      -menu .menu.label_set
	.menu.item add cascade -label [mc SetCategory]   -menu .menu.category_set
	.menu.item add command -label [mc SetComment...] -command {::Cmd::setComment}
	# SubMenu (Set Importance)
	menu .menu.importance_set -tearoff on \
	-postcommand {::Cmd::createImportanceMenu .menu.importance_set set}
	# SubMenu (Set Label)
	menu .menu.label_set -tearoff on \
	-postcommand {::Cmd::createLabelMenu .menu.label_set set}
	# SubMenu (Set Category)
	menu .menu.category_set -tearoff on \
	-postcommand {::Cmd::createCategoryMenu .menu.category_set set}

	# Menu (Database)
	menu .menu.db -tearoff no
	.menu.db add cascade -label [mc FindByImportance] -menu .menu.importance_find
	.menu.db add cascade -label [mc FindByLabel]      -menu .menu.label_find
	.menu.db add cascade -label [mc FindByCategory]   -menu .menu.category_find
	.menu.db add separator
	.menu.db add command -label [mc RebuildThumb]    -command {::Cmd::rebuildThumSel}
	.menu.db add command -label [mc RebuildThumbAll] -command {::Cmd::rebuildThumAll}
	.menu.db add separator
	.menu.db add command -label [mc InfomationOfDB...] -command {::Cmd::showDBInfo}
	# SubMenu (Find Importance)
	menu .menu.importance_find -tearoff on \
	-postcommand {::Cmd::createImportanceMenu .menu.importance_find find}
	# SubMenu (Find Label)
	menu .menu.label_find -tearoff on \
	-postcommand {::Cmd::createLabelMenu .menu.label_find find}
	# SubMenu (Find Category)
	menu .menu.category_find -tearoff on \
	-postcommand {::Cmd::createCategoryMenu .menu.category_find find}
	
	# Menu (Action)
	menu .menu.action -tearoff no 
	.menu.action add command -label [mc SlideShow...] -command {::Cmd::runSlideShow}
	.menu.action add separator
	.menu.action add cascade -label [mc OpenWith] -menu .menu.openwith
	.menu.action add separator
	.menu.action add command -label [mc FileDelete]    -command {::Cmd::deleteFile}
	.menu.action add command -label [mc FileRename...] -command {::Cmd::renameFile}
	.menu.action add command -label [mc FileMove...]   -command {::Cmd::moveFile}
	.menu.action add command -label [mc FileCopy...]   -command {::Cmd::copyFile}
	# SubMenu (Open with)
	menu .menu.openwith -tearoff on  -postcommand {::Cmd::createOpenWithMenu .menu.openwith}
	
	# Item Popup
	set M [menu .itempopmenu -tearoff no]
	$M add command -label [mc Hide] -command {::Cmd::hide}
	$M add separator
	$M add cascade -label [mc SetImportance] -menu .menu.importance_set
	$M add cascade -label [mc SetLabel]      -menu .menu.label_set
	$M add cascade -label [mc SetCategory]   -menu .menu.category_set
	$M add command -label [mc SetComment...] -command {::Cmd::setComment}
	$M add separator
	$M add command -label [mc FileDelete]    -command {::Cmd::deleteFile}
	$M add command -label [mc FileRename...] -command {::Cmd::renameFile}
	$M add command -label [mc FileMove...]   -command {::Cmd::moveFile}
	$M add command -label [mc FileCopy...]   -command {::Cmd::copyFile}
	unset M

	# Toolbar
	# ===============================================
	frame .toolbar
	pack .toolbar -fill x -padx 2 -pady 2
	# Search Button
	ComboBox .toolbar.combo -takefocus on -command {::Cmd::search}
	button   .toolbar.search -image icon_find \
		-relief flat -overrelief raised -border 1 \
		-command {::Cmd::search}
	Separator   .toolbar.sep -orient vertical
	pack .toolbar.combo .toolbar.search -side left
	pack .toolbar.sep -side left -fill y -padx 3
	::SearchBox::init .toolbar.combo

	# Change ThumbView <-> TableListView
	radiobutton .toolbar.viewlist -variable ::pref(view) -value list \
		-indicator off -offrelief flat -overrelief raised \
		-border 1 -image icon_viewlist -text List \
		-command {set ::pref(tree) list}
	radiobutton .toolbar.viewthum -variable ::pref(view) -value thum \
		-indicator off -offrelief flat -overrelief raised \
		-border 1 -image icon_viewthum -text Thumbnail \
		-command {set ::pref(tree) thum}
	radiobutton .toolbar.viewprev -variable ::pref(view) -value prev \
		-indicator off -offrelief flat -overrelief raised \
		-border 1 -image icon_viewprev -text List \
		-command {::Cmd::setPreview}
	pack .toolbar.viewlist .toolbar.viewthum .toolbar.viewprev -side left
	# Event for Change View
	trace add variable ::pref(view) {write} { \
		::Cmd::changeView .main.thum .main.prev $::pref(view);#}
	
	Separator   .toolbar.sep1 -orient vertical
	pack .toolbar.sep1 -side left -fill y -padx 3
	# Sort
	button .toolbar.sort -text sort -image icon_sort -border 1\
		-relief flat -overrelief raised -border 1
	set M [menu .toolbar.sort.menu -title [mc Sort]]
	$M add command -label [mc FileName] -command {::ThumList::sort filename}
	$M add command -label [mc Type]     -command {::ThumList::sort type}
	$M add command -label [mc Width]    -command {::ThumList::sort width}
	$M add command -label [mc Height]   -command {::ThumList::sort height}
	$M add command -label [mc Size]     -command {::ThumList::sort size}
	$M add command -label [mc CreatedDate]  -command {::ThumList::sort ctime}
	$M add command -label [mc ModifiedDate] -command {::ThumList::sort mtime}
	$M add command -label [mc Importance]   -command {::ThumList::sort importance}
	$M add command -label [mc Label]    -command {::ThumList::sort label}
	$M add command -label [mc Random]   -command {::ThumList::sort random}
	::Cmd::create_optionmenu .toolbar.sort $M
	pack .toolbar.sort -side left
	unset M
	# Preview Zoom Mode
	button .toolbar.zoom -text zoom -image icon_zoom -border 1\
		-relief flat -overrelief raised -border 1
	set M [menu .menu.zoom -title [mc Zoom]]
	::Prev::initPopMenu $M
	::Cmd::create_optionmenu .toolbar.zoom $M
	pack .toolbar.zoom -side left
	unset M
	# StatusBar
	# ===============================================
	frame .statusbar
	label .statusbar.info -textvariable ::StatusBar::text
	pack .statusbar.info -side left
	pack .statusbar -side bottom -fill both

	# Base Frame
	# ===============================================
	frame .main
	frame .main.thum
	frame .main.prev
	
	# ThumbList
	# ===============================================
	scrollbar .main.thum.y -command {.main.thum.tree yview}
    set T [treectrl .main.thum.tree -selectmode extended \
        -yscrollcommand {.main.thum.y set} -doublebuffer none]
	menu .main.thum.tree.headermenu -tearoff off
	pack .main.thum.y -side right -fill y
	pack $T -expand yes -fill both
	# Create Event
	$T notify install event Header
	$T notify install detail Header invoke
	$T notify bind $T <Header-invoke> { 
		::ThumList::sort %C
	}
	# Selection Change
	$T notify bind $T <Selection> {
		set desc [lindex %S end]
		if {$desc!={}} {
			set ::StatusBar::text \
				[::ThumList::getInfoString $desc $::StatusBar::format]
		} else {
			set ::StatusBar::text {}
		}
		::Cmd::changeSelectionInfo
	}
#    bind $T <1> {
#        set iteminfo [%W identify %x %y]
#        if {[lindex $iteminfo 0] != {item}} {return}
#        set desc [lindex $iteminfo 1]
#        set StatusBar::text [ThumList::getInfoString $desc $StatusBar::format]
#    } 

	bind $T <3> {
		set iteminfo [%W identify %x %y]
		set type [lindex $iteminfo 0]
		if {$type == {header}} {
			tk_popup .main.thum.tree.headermenu %X %Y
		} elseif {$type == {item}} {
			tk_popup .itempopmenu %X %Y
		}
	} 
	bind $T <Double-1> {
		set iteminfo [%W identify %x %y]
		if {$iteminfo=={}} {::ThumList::setSelection {}}
		if {[lindex $iteminfo 0] != {item}} {return}
		#First we need to pack .main.prev before call Cmd::setPreview.
		set ::pref(view) prev;
		::Cmd::setPreview
	}
	unset T

	ThumList::init .main.thum.tree
	ThumList::initHeaderPopMenu .main.thum.tree.headermenu
	ThumList::switchView thum
	
	# Image Preview
	# ===============================================
	canvas .main.prev.cnv -takefocus on
	pack .main.prev.cnv -fill both -expand yes
	bind .main.prev.cnv <B1-Motion>     {::Prev::dragMove %x %y}
	bind .main.prev.cnv <1>             {focus .main.prev.cnv;  ::Prev::dragStart %x %y}
	bind .main.prev.cnv <Double-1>      {set ::pref(view) $::pref(tree)}
	bind .main.prev.cnv <KeyPress-Up>   {
		set desc [::ThumList::getPrevDesc [::ThumList::getDesc $::Prev::pref(id)]]
		set ::Prev::pref(id) [::ThumList::getID $desc]
		::ThumList::setSelection $desc
		::Prev::setImage
	}
	bind .main.prev.cnv <KeyPress-Down> {
		set desc [::ThumList::getNextDesc [::ThumList::getDesc $::Prev::pref(id)]]
		set ::Prev::pref(id) [::ThumList::getID $desc]
		::ThumList::setSelection $desc
		::Prev::setImage
	}
	bind .main.prev.cnv <MouseWheel>    {
		set desclist [ThumList::getAll]
		set olddesc [::ThumList::getDesc $::Prev::pref(id)]
		set idx [lsearch $desclist $olddesc]
		
		if {%D > 0} {incr idx -1} else {incr idx}
		if {$idx<0 || $idx>[expr [llength $desclist]-1] } {return}
		set desc [lindex $desclist $idx]
		set ::Prev::pref(id) [::ThumList::getID $desc]
		::ThumList::setSelection $desc
		::Prev::setImage
	}
	::Prev::init .main.prev.cnv
	bind .main.prev.cnv <3> {
	tk_popup .menu.zoom %X %Y
	} 
	
	pack .main.thum -expand yes -fill both
	pack .main -expand yes -fill both

	# ShortCut
	set chk {if {[focus] == {.toolbar.combo.e}} {return};}
	bind . <KeyPress-0> "$chk; ::Cmd::changeImportance \[::ThumList::getSelected\] 0"
	bind . <KeyPress-1> "$chk; ::Cmd::changeImportance \[::ThumList::getSelected\] 1"
	bind . <KeyPress-2> "$chk; ::Cmd::changeImportance \[::ThumList::getSelected\] 2"
	bind . <KeyPress-3> "$chk; ::Cmd::changeImportance \[::ThumList::getSelected\] 3"
	bind . <KeyPress-4> "$chk; ::Cmd::changeImportance \[::ThumList::getSelected\] 4"
	bind . <KeyPress-5> "$chk; ::Cmd::changeImportance \[::ThumList::getSelected\] 5"
	bind . <KeyPress-6> "$chk; ::Cmd::changeImportance \[::ThumList::getSelected\] 6"
	bind . <KeyPress-7> "$chk; ::Cmd::changeImportance \[::ThumList::getSelected\] 7"
	bind . <KeyPress-8> "$chk; ::Cmd::changeImportance \[::ThumList::getSelected\] 8"
	bind . <KeyPress-9> "$chk; ::Cmd::changeImportance \[::ThumList::getSelected\] 9"
	bind . <Control-KeyPress-0> {::Cmd::changeLabel [::ThumList::getSelected] 0}
	bind . <Control-KeyPress-1> {::Cmd::changeLabel [::ThumList::getSelected] 1}
	bind . <Control-KeyPress-2> {::Cmd::changeLabel [::ThumList::getSelected] 2}
	bind . <Control-KeyPress-3> {::Cmd::changeLabel [::ThumList::getSelected] 3}
	bind . <Control-KeyPress-4> {::Cmd::changeLabel [::ThumList::getSelected] 4}
	bind . <Control-KeyPress-5> {::Cmd::changeLabel [::ThumList::getSelected] 5}
	bind . <Control-KeyPress-6> {::Cmd::changeLabel [::ThumList::getSelected] 6}
	bind . <Control-KeyPress-7> {::Cmd::changeLabel [::ThumList::getSelected] 7}
	bind . <Control-KeyPress-8> {::Cmd::changeLabel [::ThumList::getSelected] 8}
	bind . <Control-KeyPress-9> {::Cmd::changeLabel [::ThumList::getSelected] 9}
	
    wm geometry . 480x320
}

createMainWindow
