#!/bin/sh
# 200403-17 e[uc[𖼑OŃ\[g
# the next line restarts using wish \
exec wish "$0" ${1+"$@"}

package require sqlite
package require Tktable
package require BWidget

#source [file join [pwd] Images.tcl]  ;#C[Wt@C̓ǂݍ
array set img {}
set img(db)     [image create photo icndb -data {
R0lGODlhEAAQAKIAAAAAAP//mYDVAGikF5n/AP//zP///wAAACH5BAUUAAYA
LAAAAAAQABAAAANHaLrcDTDCB4u9Nhpgg/+gV4WkCAhoGaBDRaxojBJCyxUv
Qe+xjQc6AU9Yq/yCO1qRk+MpWcYmkeeTOmutDQR41TAkEodYnAAAOw==
}]
set img(folder) [image create photo icnfolder -data {
R0lGODlhEAAQAKIAAAAAAMDAwP//AICAAP//4f///wAAAAAAACH5BAUUAAUA
LAAAAAAQABAAAAM3WLrcCxA6BkSwAsxSr89RCBBkaZoQgX3skLIr5o4xHMyE
HeN1jesfHtDy6wUhg6RyuRQ5nZtNAgA7
}]
set img(table)  [image create photo icntable -data {
R0lGODlhEAAQALMAAAAAAJ3/3zJWVd/f/4OCu7a11ydDQmZmZpmZmf///wAA
AAAAAAAAAAAAAAAAAAAAACH5BAUUAAkALAAAAAAQABAAAAROMMlJawI4643R
OYIHiqGACaiBCmrKYsEwFPFc0wMmz3vRy5iCkCAsEIdCmAxnW8Z0y180Byge
jdYk4MZ1UqW8aRBJxhaUzTSOw9ZY3pMIADs=
}]
set img(view)   [image create photo icnview -data {
R0lGODlhEAAQAJEAAAAAAAC1tQD//////yH5BAUUAAMALAAAAAAQABAAAAIx
nI+pywOd3lPTzHqkzXHj7gGiJX6AgAYiKqjI2apw4GZtuwb4S9dAbyqRRpCi
8agoAAA7
}]
set img(trigger)   [image create photo icntrigger -data {
R0lGODlhEAAQAJEAAAAAAAC1tQD//////yH5BAUUAAMALAAAAAAQABAAAAIx
nI+pywOd3lPTzHqkzXHj7gGiJX6AgAYiKqjI2apw4GZtuwb4S9dAbyqRRpCi
8agoAAA7
}]
set img(pkey) [image create photo icnpkey -data {
R0lGODlhBwAKAKIAAAAAAOHhAE9PAP//AP///wAAAAAAAAAAACH5BAUUAAQA
LAAAAAAHAAoAAAMaSLCr8yOsIYCQIGgNFBgN4XTiGH4RiUoisyQAOw==
}]



array set pref {
	appname		tkSQLGUI
	edittable	false
	dbhistory   {}
}

array set database {
	path	{}
	name	{}
	table	{}
	view	{}
}

array set frameinfo {
	sql_h		100
	history_h	100
	dragged		false
}


array set fproperty {} ;#property frames pathnames
array set color {
	 titlebg #222266
	 titlefg white
	 tselbg  skyblue
}


namespace eval Tooltip {
	array set info {}
	
	proc create {} {	
		option add *Balloonhelp*background white widgetDefault
		option add *Balloonhelp*foreground black widgetDefault
		
		toplevel .tooltip -class Balloonhelp \
			-background black -borderwidth 1 -relief flat
		
		label .tooltip.info -pady 0
		pack .tooltip.info -side left -fill y
		wm overrideredirect .tooltip 1
		wm withdraw .tooltip
	}
	
	proc addWin {win str} {
		set ::Tooptip::info($win) $str
	}
	
	proc bindWin {win str} {
		addWin $win $str
		bind $win <Enter> { ::Tooltip::show %W }
		bind $win <Leave> { ::Tooltip::hide }
	}
	
	proc show {win} {
		set x [expr [winfo rootx $win] + 10]
		set y [expr [winfo rooty $win] + [winfo height $win]+10]
		wm geometry .tooltip +$x+$y
		.tooltip.info config -text $::Tooltip::info($win)
		wm deiconify .tooltip
		raise .tooltip
	}

	proc hide {} {
		wm withdraw .tooltip
	}

}



# ----------------------------------------------------------------
namespace eval Dbtree {
	
	proc editTable {node} {
		set data [.dbtree.f.tree itemcget $node -data]
		set name [lindex $data 1]
		if {$data=={}} return

		switch [.dbtree.f.tree parent $node] {
			roottable { ::editTable $name }
			rootview  { ::showTable "select * from $name" "\\[$name\]"}
		}
	}


	proc updateProperty {tree node} {
		::Property::update $tree $node
	}
	
	
	proc clear {} {
		.dbtree.f.tree delete [.dbtree.f.tree nodes root]
	}
	
	
	proc update {} {
		::Dbtree::clear
		.dbtree.f.tree insert end root rootdb \
			-text $::database(name) -image $::img(db) -open yes
		.dbtree.f.tree insert end rootdb roottable \
			-text e[u -image $::img(folder) -open yes
		.dbtree.f.tree insert end rootdb rootview \
			-text r[ -image $::img(folder) -open yes
		# table
		foreach table $::database(table) {
			set name [lindex $table 1]
			.dbtree.f.tree insert end roottable $::database(name)_table_$name \
				-image $::img(table) -text $name -data $table 
		}
		# view
		foreach view $::database(view) {
			set name [lindex $view 1]
			.dbtree.f.tree insert end rootview $::database(name)_view_$name \
				-image $::img(view) -text $name -data $view
		}
	}
}


namespace eval Property {
	variable type 
	array set field {
		0,0	{}
		0,1	Column
		0,2 Type
		0,3 Null
		0,4 Default
	}
	array set index {
		0,0 Name
		0,1 Unique
		0,2 Column
	}
	array set trigger {
		0,0 Name
	}
	
	proc clear {} {
		.property.title configure -text {} -image {}
		$::fproperty(field).table configure -rows 0
		$::fproperty(index).table configure -rows 0
		$::fproperty(trigger).table configure -rows 0
	}
	
	proc update {tree node} {
		variable type
		if {$tree=={} || $node=={}} {
			clear
			return
		}
		set data [$tree itemcget $node -data]
		set name [lindex $data 1]
		# change title
		.property.title configure \
			-text   [$tree itemcget $node -text] \
			-image  [$tree itemcget $node -image]
		# if node is folder or db then clear and return
		if {$data=={}} {
			set type {}
			clear
			return
		}
		#set field
		setField $name
		#set index
		setIndex $name
		#set trigger
		setTrigger $name
	}
	
	proc setField {table} {
		#table ̗vf
		set colpkey 0
		set colname 1
		set coltype 2
		set colnull 3
		set coldef  4
		set clist [::Sqlite::getColumnList $table]
		
		set row 1
		foreach cdata $clist {
			foreach {name typeshow type null def pkey} $cdata {
				$::fproperty(field).table configure -rows [expr $row+1]
				if {$null==0} {
					set null yes
				} else {
					set null {}
				}

				set ::Property::field($row,$colname) $name
				set ::Property::field($row,$colnull) $null
				set ::Property::field($row,$coltype) $typeshow
				set ::Property::field($row,$coldef)  $def
				if {$pkey==1} {
					$::fproperty(field).table tag cell pkey $row,$colpkey
				} else {
					$::fproperty(field).table tag cell {} $row,$colpkey
				}
			}
			incr row
		}
	}
	

	proc setIndex {tablename} {
		#table̗vf
		set colname 0
		set coluniq 1
		set colcol  2
		set ilist [::Sqlite::getIndexList $tablename]
		
		set row 1
		foreach data $ilist {
			foreach {name unique cols} $data {
				if {$unique==1} {
					set unique yes
				} else {
					set unique {}
				}
				set ::Property::index($row,$colname) $name
				set ::Property::index($row,$coluniq) $unique
				set ::Property::index($row,$colcol)  $cols
			}
			incr row
		}
		$::fproperty(index).table configure -rows $row
	}
	


	proc setTrigger {tablename} {
		#table̗vf
		set colname 0
		
		set tlist [::Sqlite::getTriggerList $tablename]
		set row 1
		foreach data $tlist {
			foreach {name sql} $data {
				# regsub -all -- {\r|\n} $sql { } sql
				set ::Property::trigger($row,$colname) $name
			}
			incr row
		}
		$::fproperty(trigger).table configure -rows $row
	}
}


namespace eval Result {
	array set table {}
	array set rowid {}
	
	variable editable 0
	array set edit {
		mode  0
		start 0
		table {}
		column {}
		index {}
		value {}
	}
	# Z̒l̕ҏWJn
	proc startEdit {} {
		set index [.result.f.table tag cell active]
		if {[scan $index %d,%d row col] != 2} return
		if {$row==0 || $col==0} return

		set ::Result::edit(start) 1 
		set ::Result::edit(value) [.result.f.table get active]
		set ::Result::edit(index) $index

		.result.f.table configure -state normal
		
	}

	# Z̒l]ĕҏW𔲂
	proc endEdit {} {
		set oldval $::Result::edit(value) 
		set newval [.result.f.table get $::Result::edit(index)]
		set table  $::Result::edit(table)
		scan $::Result::edit(index) %d,%d row col
		
		if {$oldval != $newval} {
			set coldata [lindex $::Result::edit(column) [expr $col-1]]
			set rowid $::Result::rowid($row,1)

			if {[::isNumber $newval]} {
				set value $newval
			} else {
				set value "'$newval'"
			}
			if {$newval=={}} {set value NULL}
			
			set query "update $table set [lindex $coldata 0]=$value where rowid=$rowid"
			# SQL̖₢킹Ɏsꍇ
			if {[::Sqlite::evalQuery $query]==1} {
				set ::Result::table(index) $oldval
			}
			
			#XV
			::Sqlite::publish "select * from $table" ::Result::table
			::Sqlite::publish "select rowid from $table" ::Result::rowid
			::Result::update
		}

		
		.result.f.table configure -state disabled
		set ::Result::edit(start) 0
		set ::Result::edit(value) {}
		set ::Result::edit(index) {}
	}

	

	proc setEditable {editable tablename} {
		if {$editable==1 || $editable==yes} {
			set ::Result::editable 1
			set ::Result::edit(table) $tablename
			set ::Result::edit(column) [::Sqlite::getColumnList $tablename]

			.result.f.table configure \
				-state disabled \
				-browsecommand {
					if {$::Result::edit(start)==1} {::Result::endEdit}
				} 
			bind .result.f.table <Double-1> {
				if {$::Result::edit(start)==0} {::Result::startEdit}
			}

		} else {
			set ::Result::editable 0
			.result.f.table configure \
				-state disabled \
				-browsecommand {} 
			bind .result.f.table <Double-1> {}
		}
	}
	
	
	proc clear {} {
		::clearArray ::Result::table
		set ::Result::table(row) 0
		set ::Result::table(col) 0
		::Result::update
	}
	
	
	proc update {} {
		set row $::Result::table(row)
		set col $::Result::table(col)
		.result.f.table configure -rows $row -cols $col
	}

	
}


namespace eval History {
	variable val
	
	proc deleteSelection {} {
		set sel [.history.list curselection]
		if {$sel=={}} return
		set ::History::val [lreplace $::History::val $sel $sel]
	}
	
	
	proc deleteAll {} {
		set ::History::val {}
	}

	
	proc setCommand {} {
		set sel [.history.list curselection]
		if {$sel=={}} return
		.sql.f.text delete 1.0 end
		.sql.f.text insert 1.0 [lindex $::History::val $sel]
		.sql.f.text edit reset
	}
	
}


namespace eval Sqlite {
	variable db
	variable trans 0

	# create new
	# ----------------------------------
	proc create {} {
		variable db
		set filename [tk_getSaveFile]
		if { $filename == {} } return
		open $filename
	}
	# open
	# ----------------------------------
	proc open {filename} {
		if { $filename=={} } {
			set filename [tk_getOpenFile]
			if { $filename == {} } return
		}
		set ::database(path) $filename
		set ::database(name) [file tail $filename]
		cd [file dirname $filename]
		sqlite db [file tail $filename]
		setTableList
	}
	# set table and view list
	# ----------------------------------
	proc setTableList {} {
		variable db
		set ::database(table) {}
		set ::database(view) {}
		set query {select * from sqlite_master 
					where type='table' or type='view' order by name;}
		db eval $query val {
			# val(*) = type  name  tbl_name  rootpage  sql
			set l [list $val(type) $val(name) $val(tbl_name) $val(rootpage) $val(sql)]
			switch $val(type) {
				table   {lappend ::database(table) $l}
				view    {lappend ::database(view) $l}
				default {}
			}
		}
	}
	
	
	# J̃XgԂ
	proc getColumnList {table} {
		set data [db eval "PRAGMA table_info($table)"]
		set query "select sql from sqlite_master where type='table' and tbl_name='$table'"
		set sql [lindex [db eval $query] 0]
		set cols {}
		regsub -all -- {\r|\n} $sql { } str
		regexp -nocase -- {\s*create\s+table\s+(\w)+\s*\((.*)\)\s*$} $str {} tname cols
		regsub -all -- {\(\s*} $cols {(} cols
		regsub -all -- {\s*\)} $cols {)} cols
		set clist {}
		foreach {num name type null def pkey} $data {
			set r "$name\\s+$type\[\\s|\\)|,\]?"
			regsub -all -- {\(} $r {\(} r
			regsub -all -- {\)} $r {\)} r
			if {[regexp -- $r $cols] == 0} {
				set typeshow {}
			} else {
				set typeshow $type
			}
			lappend clist [list $name $typeshow $type $null $def $pkey]
		}
		return $clist
	}



	# CfbNX̃XgԂ
	proc getIndexList {table} {
		set  query "PRAGMA index_list($table)"
		set ilist {}
		foreach {num name unique} [db eval $query] {
		set data [db eval "PRAGMA index_info($name)"]
		set colnames {}
		foreach {num1 num2 colname} $data {
			lappend colnames $colname
		}
		set cols [join $colnames {, }]
		lappend ilist [list $name $unique $cols]
		}
		return $ilist

	}
	

	# gK̃XgԂ
 	proc getTriggerList {table} {
		set tlist {}
		set q "select * from sqlite_master where tbl_name='$table' and type='trigger'"
		set l [::Sqlite::getList $q]
		set row 1
		foreach {type name tbl_name page sql} $l {
			lappend tlist [list name sql]
		}
		return $tlist
	}
	

	# s邾B
	# ----------------------------------
	proc evalQuery {query} {
		if {[catch {db eval $query} msg]} {
			tk_messageBox -message $msg
			return 1
		}
		return 0
	}
	


	# sʂs̃XgɂĕԂ
	# ----------------------------------
	proc getList {query} {
		set l {}
		if {[catch {db eval $query val {
				set w {}
				foreach colname $val(*) {
					lappend w $val($colname)
				}
				lappend l $w
			}
		} msg]} {
			tk_messageBox -message $msg
			return {}
		}
		return $l
	}
	
	
	
	#e[u̔zXV
	proc publish {str tbl} {
		upvar $tbl table 
		variable db
		set col 1
		set row 1
		if {[catch {db eval $str val {
				if {$row==1} {
					set col 1
					foreach colname $val(*) {
						set table(0,$col) $colname
						incr col
					}
				}
				set col 1
				foreach colname $val(*) {
					set table($row,$col) $val($colname)
					incr col
				}
				incr row
			}
			set table(row) $row
			set table(col) $col
		} msg]} {
			tk_messageBox -message $msg
			return 1
		}
		return 0
	}

	# close
	# ----------------------------------
	proc close {} {
		variable db
		if { $::database(name) == {} } return
		db close
		::clearDatabaseInfo
		
	}

	proc vacuum {} {
		if {[::Sqlite::evalQuery {VACUUM;}]==0} {
			tk_messageBox -message ok
		}
	}

	proc checkIntegrity {} {
		set msg [db eval {PRAGMA integrity_check;}]
		tk_messageBox -message $msg
	}

}




# lǂ肷
proc isNumber {str} {
	if {[regexp -- {^[0-9]+(\.[0-9]+)?$} $str]} {
		return 1
	} else {
		return 0
	}
}



# DBJ
proc openDB {filename} {
	::Sqlite::close
	::Sqlite::open $filename
	updateFrames
}

# DB
proc closeDB {} {
	::Sqlite::close
	updateFrames
}



# SQLs
proc executeSqlCmd {} {
	set q [.sql.f.text get 1.0 "end-1 char"]
	if {[::showTable $q {s}] != 0} {
		return 1
	}
	# update table list
	if {[regexp {^\s*(create|drop)\s} $q ] != 0} {
		::Sqlite::setTableList
		updateFrames
	}
	# add history list
	if {$q != {} } {
		lappend ::History::val $q
		.history.list selection clear 0 end
		.history.list selection anchor end
		.history.list selection set end
		.history.list see end
	}
	return 0
}


# e[u\iҏWj
proc editTable {tablename} {
	::Result::setEditable 1 $tablename
	.result.l configure -text "ҏW\[ $tablename \]"
	set query "select * from $tablename"
	::Sqlite::publish $query ::Result::table
	set query "select rowid from $tablename"
	::Sqlite::publish $query ::Result::rowid
	::Result::update
}


# e[u\iҏWsj
proc showTable {sql title} {
	::Result::setEditable 0 {}
	.result.l configure -text $title
	if {[::Sqlite::publish $sql ::Result::table] != 0} {
		return 1
	}
	::Result::update
	return 0
}



#SẴt[XVBiVKDBJƁAj
proc updateFrames {} {
	::Result::clear
	
	# clear all
	if {$::database(name)=={}} {
		wm title . $::pref(appname)
		::Dbtree::clear
		::Property::clear
		return
	}
	
	# update 
	wm title . "$::pref(appname) : $::database(path)"
	::Dbtree::update
	::Property::update {} {}
}




proc writeSession {} {
	if {[catch {open ".$::pref(appname)" w} fp]} {
		return
	}
	fconfigure $fp -encoding utf-8
	puts $fp "wm geometry . [winfo geometry .]"
	puts $fp "update"
	puts $fp ".top   sash place 0 [.top   sash coord 0]"
	puts $fp ".left  sash place 0 [.left  sash coord 0]"
	puts $fp ".right sash place 0 [.right sash coord 0]"
	puts $fp ".right sash place 1 [.right sash coord 1]"
	if {$::database(name) != {}} {
	puts $fp "::openDB {$::database(path)}"
	}
	close $fp
}

proc readSession {} {
	if {[catch {open ".$::pref(appname)" r} fp]} {
		return
	}
	fconfigure $fp -encoding utf-8
	while {![eof $fp]} {
		eval [gets $fp]
	}
	close $fp

}


# Exit
proc exit_app {} {
	writeSession
	tcl_exit
}
rename exit tcl_exit
rename exit_app exit




proc clearDatabaseInfo {} {
	array set ::database {
		path	{}
		name	{}
		table	{}
		view	{}
	}
}

proc clearArray {aryname} {
	upvar $aryname lary
	set id [array startsearch lary]
	while {[set n [array nextelement lary $id]] != {}} {
		set lary($n) {}
	}

}

proc changeTableLF {table} {
	$table configure -highlightthickness 0 -bg gray60 -anchor w 
	$table tag col default 0
	$table tag config default -fg black -bg white -relief ridge
	$table tag config pkey -image $::img(pkey)
	$table tag config title -fg black -bg gray85 -relief raised 
	$table tag config sel -fg black -bg $::color(tselbg) -relief ridge
	$table tag config active -bg white -relief ridge
	for {set i 1} {$i<300} {incr i} {
	$table tag col default $i
	}
	$table configure -state disabled
	$table configure -cursor arrow
}



proc init {} {
	# create menu
	# -------------------------------------------------
	menu .mbar -bd 0
	.mbar add cascade -label t@C     -menu .mbar.file
	#.mbar add cascade -label ҏW         -menu .mbar.edit
	.mbar add cascade -label f[^x[X -menu .mbar.db
	
	# file
	menu .mbar.file -tearoff no
	.mbar.file add command -label VK쐬 \
		-command {::Sqlite::create; updateFrames;}
	.mbar.file add command -label J   -command {::openDB {}}
	.mbar.file add command -label  -command {::closeDB}
	.mbar.file add separator
	.mbar.file add command -label I -command {exit}
	
	# edit
	#menu .mbar.edit -tearoff no
	
	# database
	menu .mbar.db -tearoff no
	.mbar.db add command -label SQLs -accelerator {Ctrl+Return} -command {executeSqlCmd}
	.mbar.db add separator
	.mbar.db add command -label VACUUM         -command {::Sqlite::vacuum}
	.mbar.db add command -label `FbN -command {::Sqlite::checkIntegrity}
	.mbar.db add separator
	.mbar.db add cascade -label Encoding       -menu .mbar.db.encoding
	
	# encoding 
	menu .mbar.db.encoding -tearoff no
	foreach enc [lsort -dictionary [encoding names]] {
		.mbar.db.encoding add command -label $enc -command "encoding system $enc"
	}

	
	. configure -menu .mbar
	bind . <Control-Return> {::executeSqlCmd}
	wm protocol . WM_DELETE_WINDOW { exit }

	# create status bar
	# -------------------------------------------------
	frame .statusbar -bd 0
	label .statusbar.l -text {aa}
	pack .statusbar.l -side left
	pack .statusbar -side bottom -fill x
	
	# create base frame
	# -------------------------------------------------
	panedwindow .top   -orient horizontal -sashrelief flat -handlesize 0
	panedwindow .left  -orient vertical   -sashrelief flat -handlesize 0
	panedwindow .right -orient vertical   -sashrelief flat -handlesize 0
	frame .sql -height 50
	frame .result
	frame .history -height 100
	frame .dbtree
	frame .property
	.left add .dbtree
	.left add .property
	.right add .sql
	.right add .result
	.right add .history
	.top add .left
	.top add .right
	pack .top -expand yes -fill both
	bind .top <Configure> {
		update
		.right sash place 0 0 $::frameinfo(sql_h)
		.right sash place 1 0 [expr [winfo height .] - $::frameinfo(history_h)]
	}
	bind .right <ButtonRelease-1> {
		set ::frameinfo(dragged) true
	}
	bind .sql <Configure> {
		if {$::frameinfo(dragged)==false} break
		set ::frameinfo(sql_h) [lindex [.right sash coord 0] 1]
		set ::frameinfo(dragged) false
	}
	bind .history <Configure> {
		if {$::frameinfo(dragged)==false} break
		set ::frameinfo(history_h) \
				[expr [winfo height .]-[lindex [.right sash coord 1] 1]]
		set ::frameinfo(dragged) false
	}

	# create .dbtree
	# -------------------------------------------------
	label .dbtree.l -bd 0 -anchor w -text f[^x[X \
		-bg $::color(titlebg) -fg $::color(titlefg)
	pack .dbtree.l -fill x -side top
	
	frame .dbtree.f -relief sunken -bd 1
	scrollbar .dbtree.f.y  -command {.dbtree.f.tree yview}
	Tree .dbtree.f.tree  -highlightthickness 0 -relief flat\
		-linesfill #DDDDDD \
		-redraw 1 -dropenabled 1 -dragenabled no \
		-selectcommand { ::Dbtree::updateProperty } \
		-yscrollcommand {.dbtree.f.y set}

	pack .dbtree.f.y -side right -fill y
	pack .dbtree.f.tree -expand yes -fill both
	pack .dbtree.f -expand yes -fill both
	
	.dbtree.f.tree bindText  <Double-1> { ::Dbtree::editTable }
	.dbtree.f.tree bindImage <Double-1> { ::Dbtree::editTable }
	
	

	# create .property
	# -------------------------------------------------
	label .property.l -bd 0 -anchor w -text vpeB \
		-bg $::color(titlebg) -fg $::color(titlefg)
	pack .property.l -fill x -side top
	
	label .property.title -compound left -anchor w
	pack .property.title -side top -fill x
	
	NoteBook .property.notebook
	.property.notebook insert end field -text Field
	.property.notebook insert end index -text Index
	.property.notebook insert end trigger -text Trigger
	set ::fproperty(field)   [.property.notebook getframe field]
	set ::fproperty(index)   [.property.notebook getframe index]
	set ::fproperty(trigger) [.property.notebook getframe trigger]
	
	#filed
	$::fproperty(field) configure -relief sunken -bd 1
	scrollbar $::fproperty(field).y -command {$::fproperty(field).table yview}
	table $::fproperty(field).table -rows 0 -cols 5 \
		-titlerows 1 -titlecols 1 -selecttitle 0 \
		-variable ::Property::field \
		-colstretch fill\
		-yscrollcommand {$::fproperty(field).y set}
	$::fproperty(field).table width 0 2 ;# Primary key
	$::fproperty(field).table width 1 8 ;# Column
	$::fproperty(field).table width 2 6 ;# Type
	$::fproperty(field).table width 3 3 ;# Null
	$::fproperty(field).table width 4 6 ;# Default
	::changeTableLF $::fproperty(field).table
	
	pack $::fproperty(field).y -side right -fill y
	pack $::fproperty(field).table -expand yes -fill both
	
	#index
	$::fproperty(index) configure -relief sunken -bd 1
	scrollbar $::fproperty(index).y -command {$::fproperty(index).table yview}
	table $::fproperty(index).table -rows 0 -cols 3 \
		-titlerows 1 -titlecols 0 -selecttitle 0 \
		-variable ::Property::index \
		-colstretch fill\
		-yscrollcommand {$::fproperty(index).y set}
	$::fproperty(index).table width 0 8 ;# Name
	$::fproperty(index).table width 1 4 ;# Unique
	#$::fproperty(index).table width 2 10 ;# Column
	::changeTableLF $::fproperty(index).table
	
	pack $::fproperty(index).y -side right -fill y
	pack $::fproperty(index).table -expand yes -fill both
	
	#trigger
	$::fproperty(trigger) configure -relief sunken -bd 1
	scrollbar $::fproperty(trigger).y -command {$::fproperty(trigger).table yview}
	table $::fproperty(trigger).table -rows 0 -cols 1 \
		-titlerows 1 -titlecols 0 -selecttitle 0 \
		-variable ::Property::trigger \
		-colstretch fill\
		-yscrollcommand {$::fproperty(trigger).y set}
	$::fproperty(trigger).table width 0 8 ;# Name
	::changeTableLF $::fproperty(trigger).table
	
	pack $::fproperty(trigger).y -side right -fill y
	pack $::fproperty(trigger).table -expand yes -fill both
	

	.property.notebook raise field
	pack .property.notebook -fill both -expand yes

	# create .sql
	# -------------------------------------------------
	label .sql.l -bd 0 -anchor w -text SQLR}h \
		-bg $::color(titlebg) -fg $::color(titlefg)
	pack .sql.l -fill x -side top
	
	frame .sql.f -relief sunken -bd 1
	scrollbar .sql.f.y -command {.sql.f.text yview}
	text .sql.f.text -relief flat -undo yes \
		-font {{} 12} \
		-yscrollcommand {.sql.f.y set}
	pack .sql.f.y -fill y -side right
	pack .sql.f.text -expand yes -fill both
	pack .sql.f -expand yes -fill both

	menu .sql.pop -tearoff no
	.sql.pop add command -label ɖ߂  -accelerator {Ctrl+Z} -command { catch {.sql.f.text edit undo} {} }
	.sql.pop add command -label 蒼 -accelerator {Ctrl+Y} -command  { catch {.sql.f.text edit redo} {} }
	.sql.pop add separator
	.sql.pop add command -label ؂ -accelerator {Ctrl+X} -command { tk_textCut .sql.f.text }
	.sql.pop add command -label Rs[  -accelerator {Ctrl+C} -command { tk_textCopy .sql.f.text }
	.sql.pop add command -label \t -accelerator {Ctrl+P} -command { tk_textPaste .sql.f.text }
	.sql.pop add command -label SđI -accelerator {Ctrl+/} -command { .sql.f.text tag add sel 1.0 end }
	#.sql.pop add separator

	
	bind .sql.f.text <3> {tk_popup .sql.pop %X %Y}

	# create .result
	# -------------------------------------------------
	label .result.l -bd 0 -anchor w -text e[u \
		-bg $::color(titlebg) -fg $::color(titlefg)
	pack .result.l -fill x -side top
	
	frame .result.f -relief sunken -bd 1 
	scrollbar .result.f.x -command {.result.f.table xview} -orient horizontal
	scrollbar .result.f.y -command {.result.f.table yview}
	table .result.f.table \
		-rows 0 -cols 0\
		-variable ::Result::table \
		-selectmode extended \
		-titlerows 1 -titlecols 1 -selecttitle 0 \
		-xscrollcommand {.result.f.x set} \
		-yscrollcommand {.result.f.y set} 
	.result.f.table width 0 3
	changeTableLF .result.f.table
	pack .result.f.x -fill x -side bottom
	pack .result.f.y -fill y -side right
	pack .result.f.table -fill both -expand yes
	pack .result.f -fill both -expand yes
	
	bind .result.f.table <MouseWheel> \
		{.result.f.table yview scroll [expr {-(%D/120) * 4}] units}


	# create .history
	# -------------------------------------------------
	label .history.l -bd 0 -anchor w -text R}h \
		-bg $::color(titlebg) -fg $::color(titlefg)
	pack .history.l -fill x -side top
	
	.history configure -relief sunken -bd 1
	scrollbar .history.y -command {.history.list yview}
	listbox   .history.list -relief flat \
		-highlightthickness 0 \
		-listvariable ::History::val \
		-yscrollcommand {.history.y set}
	pack .history.y -side right -fill y
	pack .history.list -expand yes -fill both

	menu .history.pop -tearoff no
	.history.pop add command -label 폜 -command {::History::deleteSelection}
	.history.pop add command -label ׂč폜 -command {::History::deleteAll}

	bind .history.list <Double-1> { ::History::setCommand }
	bind .history.list <3> {tk_popup .history.pop %X %Y}
	
	# GUI
	wm geometry . 640x480
	update
	.right sash place 0 0 100
	.right sash place 1 0 [expr [winfo height .] - 100]
}



init
readSession
